
# --- Лицензионное соглашение (license coding UTF8, general language of license text - Russian)
# (C) Белонин Сергей Станиславович, 2005. Все права зарезервированы
# 1.1 Настоящая программа для ЭВМ (именуемые далее ПО), является объектом авторского права и защищена законами РФ и
# международными соглашениями о защите авторских прав. Автор и правообладатель - Белонин Сергей Станиславович, именуемый
# далее ПРАВООБЛАДАТЕЛЬ - посредством настоящего ДОГОВОРА определяет условия и допустимые границы использования ПО третьими
# лицами (именуемыми далее ЛИЦЕНЗИАТЫ). В случае, если ЛИЦЕНЗИАТ не принимает всех условий настоящего ДОГОВОРА, он не имеет
# права использовать ПО. Факт создания копии ПО подтверждает согласие ЛИЦЕНЗАТА с настоящим ДОГОВОРОМ
# 1.2 Все права на ПО остаются у ПРАВООБЛАДТЕЛЯ и ЛИЦЕНЗИАТ не претендует на них. Ничто в настоящем договоре не подтверждает
# полный или частичный отказ ПРАВООБЛАДАТЕЛЯ от прав на ПО. Что же касается прав на использование ПО, то ЛИЦЕНЗИАТ не
# получает никаких прав на использование ПО, за исключением явно предоставляемых настоящим ДОГОВОРОМ. В том числе, включая,
# но не ограничиваясь, ЛИЦЕНЗИАТУ ЗАПРЕЩЕНО:
# - воспроизводить ПО, за исключением явно указанных в настоящем ДОГОВОРЕ случаев и оговоренных Законами РФ случаев
# - распространять ПО
# - публиковать ПО полностью или частично
# - использовать ПО в коммерческих целях
# 1.3 Настоящая программа публикуется КАК ЕСТЬ, без каких либо гарантий и обязательств. ПРАВООБЛАДАТЕЛЬ не берет на себя
# никаких обязательств, и не предоставляет никаких гарантий, связанных ПО, в том числе относительно применимости ПО для
# каких либо целей. ПРАВООБЛАДАТЕЛЬ не несет никакой ответственности за использование или неиспользование ЛИЦЕНЗАТОМ ПО,
# а также не несет никакой ответственности за любые результаты или их отсутствие, связанные с использованием или
# неиспользованием ЛИЦЕНЗАТОМ ПО
# 1.4 ЛИЦЕНЗАТ имеет право знакомится с ПО в личных познавательных целях, а также распространять ссылки на ПО и
# ПРАВООБЛАДАТЕЛЯ. Распространение непосредственно ПО запрещено
# 1.5 ЛИЦЕНЗАТ, являющийся физическим лицом, имеет право безвозмездно сделать одну копию размещённого на сайте ПРАВООБЛАДАТЕЛЯ
# ПО - всех или части файлов ПО - на свой персональный компьютер, а также имеет право безвозмездно запускать скопированную
# таким образом копию ПО на своём персональном компьютере, за исключением копирования и запуска размещённого на сайте
# ПРАВООБЛАДАТЕЛЯ ПО с коммерческими целями. Копирование и запуск размещённого на сайте ПО с коммерческими целями 
# запрещены. При этом описанные в настоящем разделе копирование и запуск ПО ЛИЦЕНЗАТ производит исключительно на свой страх
# и риск. ПЛИЦЕНЗАТ принимает на себя всю ответственность за использование или неиспользование ПО. ЛИЦЕНЗАТ принимает на
# себя всю ответственность за любые результаты или их отсутствие, связанные с использованием или неиспользованием ПО
# 1.6 К ЛИЦЕНЗАТАМ - физическим лицам, означенным в пункте 1.5 приравниваются государственные учреждения дошкольного,
#  школьного начального, среднего общего и среднего специального образования Российской Федерации
# 1.7 ЛИЦЕНЗИАТ обязуется не наносить интересам ПРАВООБЛАДАТЕЛЯ какой либо урон и не ущемлять интересы ПРАВООБЛАДАТЕЛЯ каким
# либо образом, связанным с использованием или не использованием ПО, и результатов или их отсутствия использования или
# неиспользования ПО
# 1.8 В случае неоднозначностей, противоречий или непонимания, в результате которых интересы ПРАВООБЛАДАТЕЛЯ могут быть
# ущемлены, ЛИЦЕНЗИАТ обязан получить у ПРАВООБЛАДАТЕЯ письменное разъяснение и руководствоваться им при использовании ПО.
# До получения письменного разъяснения ЛИЦЕНЗАТ обязан воздержаться от использования ПО
# 1.9 Если какая либо часть настоящего ДОГОВОРА будет признана не соответствующей требованиям Законов Российской Федерации,
# все остальные части настоящего ДОГОВОРА не теряют своей силы
# 2.0 В остальном стороны руководствуются законодательством РФ, возникшие разногласия урегулируются в суде, правомочным
# разрешать возникшие разногласия, по выбору ПРАВООБЛАДАТЕЛЯ

# --- LICENSE (general language of license text - Russian)
# (C) Sergey S. Belonin, 2005. All rights reserved
# Attention ! This program are protected by law and international agreements.
# You can create one copy on you personal computer, and call this program for personal noncommercial goals,
#  like as education, on you personal computer.
# You can't modify this program, include it in you developers, public, redistribute this program.
# This program are published AS IS, without any warranty.
# If you don't agree with all - don't use this program


CREATE USER cosiculs PASSWORD 'cosiculspassword' ;
CREATE DATABASE cosiculs ;

CREATE TABLE "ulog_summator" (
        "ulog_record_timestamp" timestamp DEFAULT date_trunc('second', localtimestamp),
        "ulog_prefix"           character varying(32),
        "ip_interface_input"    character varying(32),
        "ip_interface_output"   character varying(32),
        "ip_totlen"             integer,
        "ip_protocol"           smallint,
        "ip_addr_source"        inet,
        "ip_addr_destination"   inet,
        "port_source"           integer,
        "port_destination"      integer
        );


GRANT ALL PRIVILEGES ON seq_ulog TO cosiculs ;
GRANT ALL PRIVILEGES ON ulog TO cosiculs ;
GRANT ALL PRIVILEGES ON seq_ulog_summator TO cosiculs ;
GRANT ALL PRIVILEGES ON ulog_summator TO cosiculs ;
ALTER TABLE ulog OWNER TO cosiculs ;
ALTER TABLE ulog_summator OWNER TO cosiculs ;
