#!/usr/bin/perl


# --- Лицензионное соглашение (license coding UTF8, general language of license text - Russian)
# (C) Белонин Сергей Станиславович, 2005. Все права зарезервированы
# 1.1 Настоящая программа для ЭВМ (именуемые далее ПО), является объектом авторского права и защищена законами РФ и
# международными соглашениями о защите авторских прав. Автор и правообладатель - Белонин Сергей Станиславович, именуемый
# далее ПРАВООБЛАДАТЕЛЬ - посредством настоящего ДОГОВОРА определяет условия и допустимые границы использования ПО третьими
# лицами (именуемыми далее ЛИЦЕНЗИАТЫ). В случае, если ЛИЦЕНЗИАТ не принимает всех условий настоящего ДОГОВОРА, он не имеет
# права использовать ПО. Факт создания копии ПО подтверждает согласие ЛИЦЕНЗАТА с настоящим ДОГОВОРОМ
# 1.2 Все права на ПО остаются у ПРАВООБЛАДТЕЛЯ и ЛИЦЕНЗИАТ не претендует на них. Ничто в настоящем договоре не подтверждает
# полный или частичный отказ ПРАВООБЛАДАТЕЛЯ от прав на ПО. Что же касается прав на использование ПО, то ЛИЦЕНЗИАТ не
# получает никаких прав на использование ПО, за исключением явно предоставляемых настоящим ДОГОВОРОМ. В том числе, включая,
# но не ограничиваясь, ЛИЦЕНЗИАТУ ЗАПРЕЩЕНО:
# - воспроизводить ПО, за исключением явно указанных в настоящем ДОГОВОРЕ случаев и оговоренных Законами РФ случаев
# - распространять ПО
# - публиковать ПО полностью или частично
# - использовать ПО в коммерческих целях
# 1.3 Настоящая программа публикуется КАК ЕСТЬ, без каких либо гарантий и обязательств. ПРАВООБЛАДАТЕЛЬ не берет на себя
# никаких обязательств, и не предоставляет никаких гарантий, связанных ПО, в том числе относительно применимости ПО для
# каких либо целей. ПРАВООБЛАДАТЕЛЬ не несет никакой ответственности за использование или неиспользование ЛИЦЕНЗАТОМ ПО,
# а также не несет никакой ответственности за любые результаты или их отсутствие, связанные с использованием или
# неиспользованием ЛИЦЕНЗАТОМ ПО
# 1.4 ЛИЦЕНЗАТ имеет право знакомится с ПО в личных познавательных целях, а также распространять ссылки на ПО и
# ПРАВООБЛАДАТЕЛЯ. Распространение непосредственно ПО запрещено
# 1.5 ЛИЦЕНЗАТ, являющийся физическим лицом, имеет право безвозмездно сделать одну копию размещённого на сайте ПРАВООБЛАДАТЕЛЯ
# ПО - всех или части файлов ПО - на свой персональный компьютер, а также имеет право безвозмездно запускать скопированную
# таким образом копию ПО на своём персональном компьютере, за исключением копирования и запуска размещённого на сайте
# ПРАВООБЛАДАТЕЛЯ ПО с коммерческими целями. Копирование и запуск размещённого на сайте ПО с коммерческими целями 
# запрещены. При этом описанные в настоящем разделе копирование и запуск ПО ЛИЦЕНЗАТ производит исключительно на свой страх
# и риск. ПЛИЦЕНЗАТ принимает на себя всю ответственность за использование или неиспользование ПО. ЛИЦЕНЗАТ принимает на
# себя всю ответственность за любые результаты или их отсутствие, связанные с использованием или неиспользованием ПО
# 1.6 К ЛИЦЕНЗАТАМ - физическим лицам, означенным в пункте 1.5 приравниваются государственные учреждения дошкольного,
#  школьного начального, среднего общего и среднего специального образования Российской Федерации
# 1.7 ЛИЦЕНЗИАТ обязуется не наносить интересам ПРАВООБЛАДАТЕЛЯ какой либо урон и не ущемлять интересы ПРАВООБЛАДАТЕЛЯ каким
# либо образом, связанным с использованием или не использованием ПО, и результатов или их отсутствия использования или
# неиспользования ПО
# 1.8 В случае неоднозначностей, противоречий или непонимания, в результате которых интересы ПРАВООБЛАДАТЕЛЯ могут быть
# ущемлены, ЛИЦЕНЗИАТ обязан получить у ПРАВООБЛАДАТЕЯ письменное разъяснение и руководствоваться им при использовании ПО.
# До получения письменного разъяснения ЛИЦЕНЗАТ обязан воздержаться от использования ПО
# 1.9 Если какая либо часть настоящего ДОГОВОРА будет признана не соответствующей требованиям Законов Российской Федерации,
# все остальные части настоящего ДОГОВОРА не теряют своей силы
# 2.0 В остальном стороны руководствуются законодательством РФ, возникшие разногласия урегулируются в суде, правомочным
# разрешать возникшие разногласия, по выбору ПРАВООБЛАДАТЕЛЯ

# --- LICENSE (general language of license text - Russian)
# (C) Sergey S. Belonin, 2005. All rights reserved
# Attention ! This program are protected by law and international agreements.
# You can create one copy on you personal computer, and call this program for personal noncommercial goals,
#  like as education, on you personal computer.
# You can't modify this program, include it in you developers, public, redistribute this program.
# This program are published AS IS, without any warranty.
# If you don't agree with all - don't use this program


sub sztoint($) { my $data = $_[0] ; my $sztoint_result = "" ;
    for ($i=0;$i<length($data);$i++) { my $curr_enc_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i,1) ; $form_curr_char = sprintf "%03d", ord($curr_char) ; $sztoint_result = $sztoint_result . $form_curr_char ;
        }
    return $sztoint_result ;
    }

sub inttosz($) { my $data = $_[0] ; my $inttosz_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $curr_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i*3,3) ; $form_curr_char = sprintf "%c", $curr_char ; $inttosz_result = $inttosz_result . $form_curr_char ;
        }
    return $inttosz_result ;
    }

sub data_encode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $encrypt_result = "" ; my $form_curr_enc_char = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_enc_char = "" ; my $curr_enc_char = "" ; my $form_curr_enc_char = "" ;
        $work_curr_enc_char = substr($data,$i*3,3) + substr($key,$cnt_key_position*3,3) ;
        if ( $work_curr_enc_char >= 255 ) { $curr_enc_char = $work_curr_enc_char - 255 ; } else { $curr_enc_char = $work_curr_enc_char ; } 
        $form_curr_enc_char = sprintf "%03d", $curr_enc_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $encrypt_result = $encrypt_result . $form_curr_enc_char ;
        }
    return $encrypt_result ;
    }

sub data_decode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $decrypt_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_dec_char = "" ; my $curr_dec_char = "" ; my $form_curr_dec_char = "" ;
        $work_curr_dec_char = abs(substr($data,$i*3,3)) - abs(substr($key,$cnt_key_position*3,3)) ;
        if ( $work_curr_dec_char < 0 ) { $curr_dec_char = $work_curr_dec_char + 255 ; } 
        else { $curr_dec_char = $work_curr_dec_char ; } 
        $form_curr_dec_char = sprintf "%03d", $curr_dec_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $decrypt_result = $decrypt_result . $form_curr_dec_char ;
        }
    return $decrypt_result ;
    }

$filtercfg = "/usr/local/cosiculs/etc/iprules.conf" ;
$softVersion = "getUlogPgSQL v.3.21" ;

# подготовить идентификатор записи дя журналирования
$dtStamp = `date "+%Y-%m-%d %H:%M:%S"` ; $dtStamp =~ s/[\r\n\t]*//g ;
$host = `hostname` ; $host =~ s/[\r\n\t]*//g ;
$logID = $dtStamp . " " . $host . " " . $$ . " " . $softVersion ; 

$PGPASSWORD = "cosiculspassword" ;
$ENV{PGPASSWORD} = $PGPASSWORD ;

$PGSQLUSER = "cosiculs" ;
$PGSQLCONNECT = "/usr/bin/psql -U $PGSQLUSER -d cosiculs -h 127.0.0.1 -A " ;

# обработать конфигурационный файл и перевести данные из читабельного формата в технологический
open(OPT, $filtercfg) || die "ОШИБКА. Не нахожу файла конфигурации !!!\n" ;
$numSection = 0 ;
while (<OPT>) {
# --- определить номер секции
      if ($_ =~ /^\s*\[.?[Ss][Tt][Aa][Rr][Tt].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; $typeSection = $1 ; $numSection = $2 ; }
      elsif ($_ =~ /^\s*\[.?[Ss][Tt][Oo][Pp].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; 
# --------- проверить на непересекаемость секции
            if ($2 ne $numSection || $1 ne $typeSection ) { die "ОШИБКА. Секции не должны пересекаться !!!" ; } 
# --------- инициализировать элемент списка массивом значений секции
	    else { 
	         if ($numSection eq "") { die "ОШИБКА. Не определена переменная numSection в заголовке текущей секции." ; }
                 if ($typeSection eq "") { die "ОШИБКА. Не определена переменная typeSection в заголовке текущей секции." ; }
# -------------- COMMON sections
                 if ( $typeSection =~ /[Cc][Oo][Mm][Mm][Oo][Nn]/ ) {
# ----------------- инициализировать общесистемные переменные
                    $pathIPTables = $section{pathIPTables} ; if ($pathIPTables eq "") { die "ОШИБКА. Не определена переменная pathIPTables для текущей секции." ; }
                    $useSNATSection = $section{useSNATSection} ; if ($useSNATSection eq "") { die "ОШИБКА. Не определена переменная useSNATSection для текущей секции." ; } 
                    $serverName = $section{serverName} ; if ($serverName eq "") { die "ОШИБКА. Не определена переменная serverName для текущей секции." ; } 
                    $cityName = $section{cityName} ; if ($cityName eq "") { die "ОШИБКА. Не определена переменная cityName для текущей секции." ; } 
                    $serverList = $section{serverList} ; if ($serverList eq "") { die "ОШИБКА. Не определена переменная serverList для текущей секции." ; } 
                    $cityList = $section{cityList} ; if ($cityList eq "") { die "ОШИБКА. Не определена переменная cityList для текущей секции." ; } 
                    $confVersion = $section{confVersion} ; if ($confVersion eq "") { die "ОШИБКА. Не определена переменная confVersion для текущей секции." ; } 
                    $pathLog = $section{pathLog} ; if ($pathLog eq "") { die "ОШИБКА. Не определена переменная pathLog для текущей секции." ; } 
                    $ipt = $pathIPTables ;
                    }		 
# -------------- SANITY sections
                 if ( $typeSection =~ /[Bb][Ll][Aa][Cc][Kk][Ll][Ii][Ss][Tt]/ ) {
	            $pathToList = $section{pathToList} ; if ($pathToList eq "") { die "ОШИБКА. Не определена переменная pathToList для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$pathToList."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $blacklistSections[$#blacklistSections+1] = $aaa ;
                    }		 
# -------------- FILTER sections
                 if ( $typeSection =~ /[Ff][Ii][Ll][Tt][Ee][Rr]/ ) {
                    $intName = $section{intName}           ; if ($intName eq "") { die "ОШИБКА. Не определена переменная intName для текущей секции." ; }
# ----------------- флаг динамически инициализируемого интерфейса - если установлен, не используется IP
# ----------------- в списке антиспуфинга и в выделении типа траффика
                    $isDynInt = $section{isDynInt}               ; if ($isDynInt eq "") { die "ОШИБКА. Не определена переменная isDynInt для текущей секции." ; } 
	            $intIP = $section{intIP}                     ; if ($intIP eq "") { die "ОШИБКА. Не определена переменная intIP для текущей секции." ; }
	            $Network = $section{Network}                 ; if ($Network eq "") { die "ОШИБКА. Не определена переменная Network для текущей секции." ; }
	            $useBroadcast = $section{useBroadcast}       ; if ($useBroadcast eq "") { die "ОШИБКА. Не определена переменная useBroadcast для текущей секции." ; }
	            $ipBroadcast = $section{ipBroadcast}         ; if ($ipBroadcast eq "") { die "ОШИБКА. Не определена переменная ipBroadcast для текущей секции." ; }
	            $asServer = $section{asServer}               ; if ($asServer eq "") { die "ОШИБКА. Не определена переменная asServer для текущей секции." ; }
	            $asClient = $section{asClient}               ; if ($asClient eq "") { die "ОШИБКА. Не определена переменная intClient для текущей секции." ; }
	            $statPrefix = $section{statPrefix}           ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$intName."&".$isDynInt."&".$intIP."&".$Network."&".$useBroadcast."&".$ipBroadcast."&".$asServer."&".$asClient."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $filterSections[$#filterSections+1] = $aaa ;
                    }		 
# -------------- SNAT sections
                 if ( $typeSection =~ /[Ss][Nn][Aa][Tt]/ ) {
                    $fromIntName = $section{fromIntName} ; if ($fromIntName eq "") { die "ОШИБКА. Не определена переменная fromIntName для текущей секции." ; }
                    $fromAddr    = $section{fromAddr}    ; if ($fromAddr eq "") { die "ОШИБКА. Не определена переменная fromAddr для текущей секции." ; }
                    $toIntName   = $section{toIntName}   ; if ($toIntName eq "") { die "ОШИБКА. Не определена переменная toIntName для текущей секции." ; }
                    $toAddr      = $section{toAddr}      ; if ($toAddr eq "") { die "ОШИБКА. Не определена переменная toAddr для текущей секции." ; }
	            $allowRecord = $section{allowRecord} ; if ($allowRecord eq "") { die "ОШИБКА. Не определена переменная allowRecord для текущей секции." ; }
	            $statPrefix  = $section{statPrefix}  ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription}  ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$fromIntName."&".$fromAddr."&".$toIntName."&".$toAddr."&".$allowRecord."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
                    $snatSections[$#snatSections+1] = $aaa ;
                    }		 
		 undef($section) ;
	         }
	    }
# --- отфильтровать комментарии и пустые строки, выбрать значения
      else { if ($_ !~ /^[\s\t]*#.*/ && $_ !~ /^$/) { $_ =~ s/[\s\t\n\r]*//g ; ($key,$value) = split (/=/, $_) ; $section{$key} = $value ; } }
      }
close(OPT) ;
# завершить обработку конфигурационного файла
if ( $#blacklistSections >= 1) { @blacklistSections = sort{$a <=> $b} @blacklistSections ; }
if ( $#filterSections >= 1) { @filterSections = sort{$a <=> $b} @filterSections ; }
if ( $#snatSections >= 1) { @snatSections = sort{$a <=> $b} @snatSections ; }
@request_result = ("") ; check_hasp() ;

open(LOGTARGET, ">>$pathLog") || die "ОШИБКА. Не открывается файл журнала - $pathLog." ;
print LOGTARGET "\n\n[$logID] стартовала обработка коллектора текущей статистики\n" ;

# если в памяти уже есть копия приложения - занести факт в журнал и прервать работу
$currPID = $$ ; $currCommand = $0 ; $currCommand =~ s/.*\///g ;
@listProc = `ps xa | grep -v $currPID | grep \"$currCommand\" | grep -v grep  | grep -v ^\$` ;
if ( $#listProc > -1 ) {
   print LOGTARGET "[$logID] ВНИМАНИЕ !!! Уже запущен(ы) копии данного приложения. Сведения:\n" ; 
   print LOGTARGET "[$logID] PID текущего процесса - $currPID, командная строка $currCommand, результат поиска:\n" ;
   for ($i=0;$i<=$#listProc;$i++) { $listProc[$i] =~ s/[\r\n]//g ; print LOGTARGET "[$logID] $listProc[$i]\n" ; }
   print LOGTARGET "[$logID] текущий экземпляр обработчика будет завершен без обработки данных\n\n\n" ;
   die ; }

# получить максимальный текущий ID - для организации "СРЕЗА" данных в базе
$maxID = `$PGSQLCONNECT -t -c "select MAX(id) from ulog" | grep -v ^\$ 2>&1` ; 
$maxID =~ s/[\r\n]*//g ; if ( $maxID eq "" ) { $maxID = 0 ; } print LOGTARGET "[$logID] + максимальный ID записи среза данных - $maxID\n" ;

# обрабатываются данные по этот ID, потом они же и удаляются
$textQuery = "BEGIN; INSERT INTO ulog_summator (ulog_prefix,ip_interface_input,ip_interface_output,ip_totlen,ip_protocol,ip_addr_source,ip_addr_destination,port_source,port_destination) SELECT oob_prefix, oob_in, oob_out, SUM(ip_totlen) AS ip_totlen, ip_protocol, ip_saddr, ip_daddr, CASE WHEN ip_protocol = 6 THEN tcp_sport WHEN ip_protocol = 17 THEN udp_sport ELSE NULL END AS port_source, CASE WHEN ip_protocol = 6 THEN tcp_dport WHEN ip_protocol = 17 THEN udp_dport ELSE NULL END AS port_destination FROM ulog WHERE id <= $maxID GROUP BY oob_prefix, oob_in, oob_out, ip_saddr, ip_daddr, ip_protocol, port_source, port_destination ; DELETE FROM ulog WHERE id <= $maxID ; COMMIT ; VACUUM ulog ;" ;
@resultQuery = `echo -e \"$textQuery\" | $PGSQLCONNECT -f - 2>&1` ;
print LOGTARGET "[$logID] отработан запрос агрегации. Результат: \n" ;    
for ($i=0;$i<=$#resultQuery;$i++) { 
    $resultQuery[$i] =~ s/[\r\n]+//g ; print LOGTARGET "[$logID] + $resultQuery[$i]\n" ; }
print LOGTARGET "[$logID] завершена обработка коллектора текущей статистики\n" ;
close(LOGTARGET) ;
