#!/usr/bin/perl


# --- Лицензионное соглашение (license coding UTF8, general language of license text - Russian)
# (C) Белонин Сергей Станиславович, 2005. Все права зарезервированы
# 1.1 Настоящая программа для ЭВМ (именуемые далее ПО), является объектом авторского права и защищена законами РФ и
# международными соглашениями о защите авторских прав. Автор и правообладатель - Белонин Сергей Станиславович, именуемый
# далее ПРАВООБЛАДАТЕЛЬ - посредством настоящего ДОГОВОРА определяет условия и допустимые границы использования ПО третьими
# лицами (именуемыми далее ЛИЦЕНЗИАТЫ). В случае, если ЛИЦЕНЗИАТ не принимает всех условий настоящего ДОГОВОРА, он не имеет
# права использовать ПО. Факт создания копии ПО подтверждает согласие ЛИЦЕНЗАТА с настоящим ДОГОВОРОМ
# 1.2 Все права на ПО остаются у ПРАВООБЛАДТЕЛЯ и ЛИЦЕНЗИАТ не претендует на них. Ничто в настоящем договоре не подтверждает
# полный или частичный отказ ПРАВООБЛАДАТЕЛЯ от прав на ПО. Что же касается прав на использование ПО, то ЛИЦЕНЗИАТ не
# получает никаких прав на использование ПО, за исключением явно предоставляемых настоящим ДОГОВОРОМ. В том числе, включая,
# но не ограничиваясь, ЛИЦЕНЗИАТУ ЗАПРЕЩЕНО:
# - воспроизводить ПО, за исключением явно указанных в настоящем ДОГОВОРЕ случаев и оговоренных Законами РФ случаев
# - распространять ПО
# - публиковать ПО полностью или частично
# - использовать ПО в коммерческих целях
# 1.3 Настоящая программа публикуется КАК ЕСТЬ, без каких либо гарантий и обязательств. ПРАВООБЛАДАТЕЛЬ не берет на себя
# никаких обязательств, и не предоставляет никаких гарантий, связанных ПО, в том числе относительно применимости ПО для
# каких либо целей. ПРАВООБЛАДАТЕЛЬ не несет никакой ответственности за использование или неиспользование ЛИЦЕНЗАТОМ ПО,
# а также не несет никакой ответственности за любые результаты или их отсутствие, связанные с использованием или
# неиспользованием ЛИЦЕНЗАТОМ ПО
# 1.4 ЛИЦЕНЗАТ имеет право знакомится с ПО в личных познавательных целях, а также распространять ссылки на ПО и
# ПРАВООБЛАДАТЕЛЯ. Распространение непосредственно ПО запрещено
# 1.5 ЛИЦЕНЗАТ, являющийся физическим лицом, имеет право безвозмездно сделать одну копию размещённого на сайте ПРАВООБЛАДАТЕЛЯ
# ПО - всех или части файлов ПО - на свой персональный компьютер, а также имеет право безвозмездно запускать скопированную
# таким образом копию ПО на своём персональном компьютере, за исключением копирования и запуска размещённого на сайте
# ПРАВООБЛАДАТЕЛЯ ПО с коммерческими целями. Копирование и запуск размещённого на сайте ПО с коммерческими целями 
# запрещены. При этом описанные в настоящем разделе копирование и запуск ПО ЛИЦЕНЗАТ производит исключительно на свой страх
# и риск. ПЛИЦЕНЗАТ принимает на себя всю ответственность за использование или неиспользование ПО. ЛИЦЕНЗАТ принимает на
# себя всю ответственность за любые результаты или их отсутствие, связанные с использованием или неиспользованием ПО
# 1.6 К ЛИЦЕНЗАТАМ - физическим лицам, означенным в пункте 1.5 приравниваются государственные учреждения дошкольного,
#  школьного начального, среднего общего и среднего специального образования Российской Федерации
# 1.7 ЛИЦЕНЗИАТ обязуется не наносить интересам ПРАВООБЛАДАТЕЛЯ какой либо урон и не ущемлять интересы ПРАВООБЛАДАТЕЛЯ каким
# либо образом, связанным с использованием или не использованием ПО, и результатов или их отсутствия использования или
# неиспользования ПО
# 1.8 В случае неоднозначностей, противоречий или непонимания, в результате которых интересы ПРАВООБЛАДАТЕЛЯ могут быть
# ущемлены, ЛИЦЕНЗИАТ обязан получить у ПРАВООБЛАДАТЕЯ письменное разъяснение и руководствоваться им при использовании ПО.
# До получения письменного разъяснения ЛИЦЕНЗАТ обязан воздержаться от использования ПО
# 1.9 Если какая либо часть настоящего ДОГОВОРА будет признана не соответствующей требованиям Законов Российской Федерации,
# все остальные части настоящего ДОГОВОРА не теряют своей силы
# 2.0 В остальном стороны руководствуются законодательством РФ, возникшие разногласия урегулируются в суде, правомочным
# разрешать возникшие разногласия, по выбору ПРАВООБЛАДАТЕЛЯ

# --- LICENSE (general language of license text - Russian)
# (C) Sergey S. Belonin, 2005. All rights reserved
# Attention ! This program are protected by law and international agreements.
# You can create one copy on you personal computer, and call this program for personal noncommercial goals,
#  like as education, on you personal computer.
# You can't modify this program, include it in you developers, public, redistribute this program.
# This program are published AS IS, without any warranty.
# If you don't agree with all - don't use this program


sub sztoint($) { my $data = $_[0] ; my $sztoint_result = "" ;
    for ($i=0;$i<length($data);$i++) { my $curr_enc_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i,1) ; $form_curr_char = sprintf "%03d", ord($curr_char) ; $sztoint_result = $sztoint_result . $form_curr_char ;
        }
    return $sztoint_result ;
    }

sub inttosz($) { my $data = $_[0] ; my $inttosz_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $curr_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i*3,3) ; $form_curr_char = sprintf "%c", $curr_char ; $inttosz_result = $inttosz_result . $form_curr_char ;
        }
    return $inttosz_result ;
    }

sub data_encode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $encrypt_result = "" ; my $form_curr_enc_char = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_enc_char = "" ; my $curr_enc_char = "" ; my $form_curr_enc_char = "" ;
        $work_curr_enc_char = substr($data,$i*3,3) + substr($key,$cnt_key_position*3,3) ;
        if ( $work_curr_enc_char >= 255 ) { $curr_enc_char = $work_curr_enc_char - 255 ; } else { $curr_enc_char = $work_curr_enc_char ; } 
        $form_curr_enc_char = sprintf "%03d", $curr_enc_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $encrypt_result = $encrypt_result . $form_curr_enc_char ;
        }
    return $encrypt_result ;
    }

sub data_decode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $decrypt_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_dec_char = "" ; my $curr_dec_char = "" ; my $form_curr_dec_char = "" ;
        $work_curr_dec_char = abs(substr($data,$i*3,3)) - abs(substr($key,$cnt_key_position*3,3)) ;
        if ( $work_curr_dec_char < 0 ) { $curr_dec_char = $work_curr_dec_char + 255 ; } 
        else { $curr_dec_char = $work_curr_dec_char ; } 
        $form_curr_dec_char = sprintf "%03d", $curr_dec_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $decrypt_result = $decrypt_result . $form_curr_dec_char ;
        }
    return $decrypt_result ;
    }

$filtercfg = "/usr/local/cosiculs/etc/iprules.conf" ;
$softVersion = "ip_rules.v.3.25" ;
$dtStamp = `date "+%Y-%m-%d %H:%M:%S"` ; $dtStamp =~ s/[\r\n\t]*//g ;
$host = `hostname` ; $host =~ s/[\r\n\t]*//g ;
$logID = $dtStamp . " " . $host . " " . $$ . " " . $softVersion ; 
$optionsULOG = " --ulog-nlgroup=1 --ulog-qthreshold=50 --ulog-cprange=0" ;
$options_tcp_udp_ULOG = " --ulog-nlgroup=1 --ulog-qthreshold=50 --ulog-cprange=50" ;

# обработать конфигурационный файл и перевести данные из читабельного формата в технологический
open(OPT, $filtercfg) || die "ОШИБКА. Не нахожу файла конфигурации !!!\n" ;
$numSection = 0 ; @request_result = ("") ; check_hasp() ;
while (<OPT>) {
# --- определить номер секции
      if ($_ =~ /^\s*\[.?[Ss][Tt][Aa][Rr][Tt].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; $typeSection = $1 ; $numSection = $2 ; }
      elsif ($_ =~ /^\s*\[.?[Ss][Tt][Oo][Pp].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; 
# --------- проверить на непересекаемость секции
            if ($2 ne $numSection || $1 ne $typeSection ) { die "ОШИБКА. Секции не должны пересекаться !!!" ; } 
# --------- инициализировать элемент списка массивом значений секции
	    else { 
	         if ($numSection eq "") { die "ОШИБКА. Не определена переменная numSection в заголовке текущей секции." ; }
                 if ($typeSection eq "") { die "ОШИБКА. Не определена переменная typeSection в заголовке текущей секции." ; }
# -------------- COMMON sections
                 if ( $typeSection =~ /[Cc][Oo][Mm][Mm][Oo][Nn]/ ) {
# ----------------- инициализировать общесистемные переменные
                    $pathIPTables = $section{pathIPTables} ; if ($pathIPTables eq "") { die "ОШИБКА. Не определена переменная pathIPTables для текущей секции." ; }
                    $useSNATSection = $section{useSNATSection} ; if ($useSNATSection eq "") { die "ОШИБКА. Не определена переменная useSNATSection для текущей секции." ; } 
                    $serverName = $section{serverName} ; if ($serverName eq "") { die "ОШИБКА. Не определена переменная serverName для текущей секции." ; } 
                    $cityName = $section{cityName} ; if ($cityName eq "") { die "ОШИБКА. Не определена переменная cityName для текущей секции." ; } 
                    $serverList = $section{serverList} ; if ($serverList eq "") { die "ОШИБКА. Не определена переменная serverList для текущей секции." ; } 
                    $cityList = $section{cityList} ; if ($cityList eq "") { die "ОШИБКА. Не определена переменная cityList для текущей секции." ; } 
                    $confVersion = $section{confVersion} ; if ($confVersion eq "") { die "ОШИБКА. Не определена переменная confVersion для текущей секции." ; } 
                    $pathLog = $section{pathLog} ; if ($pathLog eq "") { die "ОШИБКА. Не определена переменная pathLog для текущей секции." ; } 
	            $isConntrackFtp = $section{isConntrackFtp}   ; if ($isConntrackFtp eq "") { die "ОШИБКА. Не определена переменная isConntrackFtp для текущей секции." ; }
# ----------------- с версии 3.25
	            $accept_target = $section{accept_target}   ; if ($accept_target eq "") { die "ОШИБКА. Не определена переменная accept_target для текущей секции." ; }
	            $drop_target = $section{drop_target}   ; if ($drop_target eq "") { die "ОШИБКА. Не определена переменная drop_target для текущей секции." ; }
                    $ipt = $pathIPTables ;
                    }		 
# -------------- SANITY sections
                 if ( $typeSection =~ /[Bb][Ll][Aa][Cc][Kk][Ll][Ii][Ss][Tt]/ ) {
	            $pathToList = $section{pathToList} ; if ($pathToList eq "") { die "ОШИБКА. Не определена переменная pathToList для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
# ----------------- с версии 3.25
                    $is_collect_stat = $section{is_collect_stat} ; if ($is_collect_stat eq "") { die "ОШИБКА. Не определена переменная is_collect_stat для текущей секции." ; }
                    $aaa = $numSection."&".$pathToList."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."&".$is_collect_stat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $blacklistSections[$#blacklistSections+1] = $aaa ;
                    }		 
# -------------- FILTER sections
                 if ( $typeSection =~ /[Ff][Ii][Ll][Tt][Ee][Rr]/ ) {
                    $intName = $section{intName}           ; if ($intName eq "") { die "ОШИБКА. Не определена переменная intName для текущей секции." ; }
# ----------------- флаг динамически инициализируемого интерфейса - если установлен, не используется IP
# ----------------- в списке антиспуфинга и в выделении типа траффика
                    $isDynInt = $section{isDynInt}               ; if ($isDynInt eq "") { die "ОШИБКА. Не определена переменная isDynInt для текущей секции." ; } 
	            $intIP = $section{intIP}                     ; if ($intIP eq "") { die "ОШИБКА. Не определена переменная intIP для текущей секции." ; }
	            $Network = $section{Network}                 ; if ($Network eq "") { die "ОШИБКА. Не определена переменная Network для текущей секции." ; }
	            $useBroadcast = $section{useBroadcast}       ; if ($useBroadcast eq "") { die "ОШИБКА. Не определена переменная useBroadcast для текущей секции." ; }
	            $ipBroadcast = $section{ipBroadcast}         ; if ($ipBroadcast eq "") { die "ОШИБКА. Не определена переменная ipBroadcast для текущей секции." ; }
	            $asServer = $section{asServer}               ; if ($asServer eq "") { die "ОШИБКА. Не определена переменная asServer для текущей секции." ; }
	            $asClient = $section{asClient}               ; if ($asClient eq "") { die "ОШИБКА. Не определена переменная intClient для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse}   ; if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix = $section{statPrefix}           ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat}       ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat}       ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
# ----------------- с версии 3.25
                    $is_collect_stat = $section{is_collect_stat} ; if ($is_collect_stat eq "") { die "ОШИБКА. Не определена переменная is_collect_stat для текущей секции." ; }
	            $is_drop_default = $section{is_drop_default} ; if ($is_drop_default eq "") { die "ОШИБКА. Не определена переменная is_drop_default для текущей секции." ; }
                    $aaa = $numSection."&".$intName."&".$isDynInt."&".$intIP."&".$Network."&".$useBroadcast."&".$ipBroadcast."&".$asServer."&".$asClient."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."&".$is_collect_stat."&".$is_drop_default."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $filterSections[$#filterSections+1] = $aaa ;
                    }		 
# -------------- SNAT sections
                 if ( $typeSection =~ /[Ss][Nn][Aa][Tt]/ ) {
                    $fromIntName = $section{fromIntName} ; if ($fromIntName eq "") { die "ОШИБКА. Не определена переменная fromIntName для текущей секции." ; }
                    $fromAddr    = $section{fromAddr}    ; if ($fromAddr eq "") { die "ОШИБКА. Не определена переменная fromAddr для текущей секции." ; }
                    $toIntName   = $section{toIntName}   ; if ($toIntName eq "") { die "ОШИБКА. Не определена переменная toIntName для текущей секции." ; }
                    $toAddr      = $section{toAddr}      ; if ($toAddr eq "") { die "ОШИБКА. Не определена переменная toAddr для текущей секции." ; }
	            $allowRecord = $section{allowRecord} ; if ($allowRecord eq "") { die "ОШИБКА. Не определена переменная allowRecord для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse}   ; if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix  = $section{statPrefix}  ; if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription}  ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ; if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ; if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
# ----------------- с версии 3.25
                    $is_collect_stat = $section{is_collect_stat} ; if ($is_collect_stat eq "") { die "ОШИБКА. Не определена переменная is_collect_stat для текущей секции." ; }
	            $is_drop_default = $section{is_drop_default} ; if ($is_drop_default eq "") { die "ОШИБКА. Не определена переменная is_drop_default для текущей секции." ; }
                    $aaa = $numSection."&".$fromIntName."&".$fromAddr."&".$toIntName."&".$toAddr."&".$allowRecord."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."&".$is_collect_stat."&".$is_drop_default."\n\n" ;
                    $snatSections[$#snatSections+1] = $aaa ;
                    }		 
		 undef($section) ;
	         }
	    }
# --- отфильтровать комментарии и пустые строки, выбрать значения
      else { if ($_ !~ /^[\s\t]*#.*/ && $_ !~ /^$/) { $_ =~ s/[\s\t\n\r]*//g ; ($key,$value) = split (/=/, $_) ; $section{$key} = $value ; } }
      }
close(OPT) ;
# завершить обработку конфигурационного файла

# пересортировать секции в соответствии с присвоенными в конфигурационном файле номерами
# чтобы обработка секций производилась последовательно по возрастанию номера
if ( $#blacklistSections >= 1) { @blacklistSections = sort{$a <=> $b} @blacklistSections ; }
if ( $#filterSections >= 1) { @filterSections = sort{$a <=> $b} @filterSections ; }
if ( $#snatSections >= 1) { @snatSections = sort{$a <=> $b} @snatSections ; }

open(LOGTARGET, ">>$pathLog") || die "ОШИБКА. Не открывается файл журнала - $pathLog." ;

print "\nСтартовал конфигуратор сетевого фильтра и статистики IP траффика\n" ;
print LOGTARGET "\n\n[$logID] Стартовал конфигуратор сетевого фильтра и статистики IP траффика\n" ;
print "Версия конфигуратора - $softVersion, версия конфигурационного файла - $confVersion\n" ;
print LOGTARGET "[$logID] Версия конфигуратора - $softVersion, версия конфигурационного файла - $confVersion\n" ;

############################################################################################################################
# Очистка таблиц и установка политик по умолчанию (ЗАПРЕТ, далее в процессе инициализации добавляются цепочки РАЗРЕШЕНИЯ)
############################################################################################################################
system "$ipt -F ; $ipt -F -t nat ; $ipt -F -t mangle ; $ipt -X ;" ;
system "$ipt -t filter -P INPUT DROP ; $ipt -t filter -P OUTPUT DROP ; $ipt -t filter -P FORWARD DROP ;" ;
system "$ipt -t nat -P PREROUTING ACCEPT ; $ipt -t nat -P POSTROUTING ACCEPT ; $ipt -t nat -P OUTPUT ACCEPT ;" ;
system "$ipt -t mangle -P INPUT ACCEPT ; $ipt -t mangle -P POSTROUTING ACCEPT ;" ;

############################################################################################################################
# Загрузка дополнительных модулей IpTables (при необходимости)
############################################################################################################################
if ( $isConntrackFtp =~ /[Yy][Ee][Ss]/ ) { 
   system(" [ \"`/sbin/lsmod | grep ip_conntrack_ftp`\" == \"\" ] && /sbin/modprobe ip_conntrack_ftp ") ;
   system(" [ \"`/sbin/lsmod | grep ip_nat_ftp`\" == \"\" ] && /sbin/modprobe ip_nat_ftp ") ; }

############################################################################################################################
# Инициализация SANITY секций
############################################################################################################################
for ($i=0;$i<=$#blacklistSections;$i++) {
    $blacklistSections[$i] =~ s/[\r\n]*//g ;
    my($numSection,$pathToList,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat,$is_collect_stat) = split(/&/, $blacklistSections[$i]) ;
    
    system "$ipt -N CHIN$statPrefix ; $ipt -N CHOUT$statPrefix ;" ;
    system "$ipt -A INPUT -j CHIN$statPrefix; $ipt -A OUTPUT -j CHOUT$statPrefix;" ; 
# - транслируемый траффик тоже завернуть во входящую SANITY цепочку. В дальнейшем весь трафик с адресов в списке
# - блокируется, и входящий, и исходящий. Так что транслируемые адреса также захватываются
    system "$ipt -A FORWARD -j CHIN$statPrefix" ;

    @blackList = `cat $pathToList | grep -v ^\$` ;
    for ($j=0;$j<=$#blackList;$j++) {
	$blackList[$j] =~ s/[\r\n\t]//g ;
# ----- инициализировать счетчики траффика с префиксом <имя>[in|out]accept
        if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) {
           system "$ipt -A CHIN$statPrefix -s $blackList[$j] -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."indrop\"" ;
           system "$ipt -A CHIN$statPrefix -d $blackList[$j] -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."indrop\"" ;
           system "$ipt -A CHOUT$statPrefix -s $blackList[$j] -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outdrop\"" ;
           system "$ipt -A CHOUT$statPrefix -d $blackList[$j] -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outdrop\"" ;
           }
# ----- создать собственно правила
        system "$ipt -A CHIN$statPrefix -s $blackList[$j] -j $drop_target" ;
        system "$ipt -A CHIN$statPrefix -d $blackList[$j] -j $drop_target" ; 
        system "$ipt -A CHOUT$statPrefix -s $blackList[$j] -j $drop_target" ; 
        system "$ipt -A CHOUT$statPrefix -d $blackList[$j] -j $drop_target" ;
        }
    }
print "+ Активация \"черных\" списков\n" ;
print LOGTARGET "[$logID] + Активация \"черных\" списков\n" ;

############################################################################################################################
# Разрешение локального траффика
############################################################################################################################
print "+ Разрешение локального траффика сервера\n" ;
print LOGTARGET "[$logID] + Разрешение локального траффика сервера\n" ;
system "$ipt -A INPUT -s 127.0.0.1 -d 127.0.0.1 -j ACCEPT ; $ipt -A OUTPUT -s 127.0.0.1 -d 127.0.0.1 -j ACCEPT ;" ;
# разрешить траффик (с и от сразу) каждого нединам. интерфейса секции фильтров
for ($i=0;$i<=$#filterSections;$i++) {
    my($numSection,$intName,$isDynInt,$intIP,$Network,$asServer,$asClient,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat,$is_collect_stat,$is_drop_default) = split(/&/, $filterSections[$i]) ;
    if ( $isDynInt =~ /[Nn][Oo]/ ) { system "$ipt -A INPUT -s $intIP -d $intIP -j ACCEPT ; $ipt -A OUTPUT -s $intIP -d $intIP -j ACCEPT ;" ; }
    }

############################################################################################################################
# Секция - Фильтры
############################################################################################################################
print "Создание цепочек потоков фильтров сетей\n" ;
print LOGTARGET "[$logID] Создание цепочек потоков фильтров сетей\n" ;
for ($i=0;$i<=$#filterSections;$i++) {
    $filterSections[$i] =~ s/[\r\n]*//g ;
    my($numSection,$intName,$isDynInt,$intIP,$Network,$useBroadcast,$ipBroadcast,$asServer,$asClient,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat,$is_collect_stat,$is_drop_default) = split(/&/, $filterSections[$i]) ;
    my(@asServerList) = split(/,/, $asServer) ; my(@asClientList) = split(/,/, $asClient) ;
# - отработать правило антиспуфинга - для нединамического интерфейса
    if ( $isDynInt =~ /[Nn][Oo]/ ) { 
       if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { system "$ipt -A INPUT -i ! $intName -s $Network -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."indrop\" ; $ipt -A OUTPUT -o ! $intName -d $Network -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outdrop\"" ; }
       system "$ipt -A INPUT -i ! $intName -s $Network -j $drop_target ; $ipt -A OUTPUT -o ! $intName -d $Network -j $drop_target  ;" ;
       }
# - создать цепочки обработки секции и зарулить в них траффик
    system "$ipt -N CHIN$statPrefix ; $ipt -N CHOUT$statPrefix ;" ;
    system "$ipt -A INPUT -i $intName -s $Network -d $intIP -j CHIN$statPrefix" ; 
    system "$ipt -A OUTPUT -o $intName -s $intIP -d $Network -j CHOUT$statPrefix" ;
# - если разрешено в конфиге - зарулить в созданные цепочки широковещательный траффик
    if ( $useBroadcast =~ /[Yy][Ee][Ss]/ ) {
       system "$ipt -A INPUT -i $intName -d $ipBroadcast -s $Network -j CHIN$statPrefix" ;
       system "$ipt -A OUTPUT -o $intName -d $Network -s $ipBroadcast -j CHOUT$statPrefix" ;
       system "$ipt -A INPUT -i $intName -d 255.255.255.255/32 -j CHIN$statPrefix" ;
       system "$ipt -A OUTPUT -o $intName -d 255.255.255.255/32 -j CHOUT$statPrefix" ;
       }
# - запрет необработанного - из цепочки локальный траффик НЕ ВЫПУСКАЕТСЯ
# - это ограничение на уровне верха списка цепочек
    if ( $is_drop_default =~ /[Yy][Ee][Ss]/ ) { system "$ipt -A INPUT -i $intName -s $Network -d $intIP -j $drop_target ; $ipt -A OUTPUT -o $intName -s $intIP -d $Network -j $drop_target ;" ; }
# - если разрешено в конфиге - разрешить state:ESTABLISHED,RELATED CONNTRACK траффик
    if ( $isConntrackUse =~ /[Yy][Ee][Ss]/ ) { 
       if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
          system "$ipt -A CHIN$statPrefix -m state --state ESTABLISHED,RELATED -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
          system "$ipt -A CHOUT$statPrefix -m state --state ESTABLISHED,RELATED -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
          }
       system "$ipt -A CHIN$statPrefix -m state --state ESTABLISHED,RELATED -j $accept_target" ;
       system "$ipt -A CHOUT$statPrefix -m state --state ESTABLISHED,RELATED -j $accept_target" ;
       }
# - разрешить icmp обмен
    if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
       system "$ipt -A CHIN$statPrefix -p icmp -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
       system "$ipt -A CHOUT$statPrefix -p icmp -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
       }
    system "$ipt -A CHIN$statPrefix -p icmp -j $accept_target" ;
    system "$ipt -A CHOUT$statPrefix -p icmp -j $accept_target" ;
# - инициализация правил, ответственных за роль "сервер" в сети интерфейса
    for ($j=0;$j<=$#asServerList;$j++) {
        my($ip,$proto,$port) = split(/#/, $asServerList[$j]) ; 
	$ipin = "" ; $ipout = "" ; if ($ip ne "") { $ipin = "-s $ip"; $ipout = "-d $ip"; }
# ----- инициализировать счетчики разрешенного траффика с префиксом <имя>[in|out]accept
        if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
           if ( $proto =~ /tcp/i || $proto =~ /udp/i ) {
              system "$ipt -A CHIN$statPrefix -p $proto $ipin --destination-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
              system "$ipt -A CHOUT$statPrefix -p $proto $ipout --source-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
	      }
           else {
                system "$ipt -A CHIN$statPrefix -p $proto $ipin --destination-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
                system "$ipt -A CHOUT$statPrefix -p $proto $ipout --source-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
                }
           }
# ----- создать собственно правила
        system "$ipt -A CHIN$statPrefix -p $proto $ipin --destination-port $port -j $accept_target" ;
        system "$ipt -A CHOUT$statPrefix -p $proto $ipout --source-port $port -j $accept_target" ;    
        }
# - инициализация правил, ответственных за роль "клиент" в сети интерфейса
    for ($k=0;$k<=$#asClientList;$k++) {
        my($ip,$proto,$port) = split(/#/, $asClientList[$k]) ;
        $ipin = "" ; $ipout = "" ; if ($ip ne "") { $ipin = "-s $ip"; $ipout = "-d $ip"; }
# ----- инициализировать счетчики разрешенного траффика с префиксом <имя>[in|out]accept
        if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
           if ( $proto =~ /tcp/i || $proto =~ /udp/i ) {
              system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
              system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
              }
           else {
                system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
                system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
                }
           }
# ----- создать собственно правила
        system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j $accept_target" ;
        system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j $accept_target" ;    
        }
# - запретить весь необработанный предидущими правилами цепочки траффик
# - это правило на уровне конца отдельной цепочки
    if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
       system "$ipt -A CHIN$statPrefix -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."indrop\"" ;
       system "$ipt -A CHOUT$statPrefix -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outdrop\"" ;    
       }
    if ( $is_drop_default =~ /[Yy][Ee][Ss]/ ) { system "$ipt -A CHIN$statPrefix -j $drop_target ; $ipt -A CHOUT$statPrefix -j $drop_target" ; }
    print "+ Инициализация цепочки правил траффика - $statPrefix\n" ;
    print LOGTARGET "[$logID] + Инициализация цепочки правил траффика - $statPrefix\n" ;
    }

############################################################################
# SNAT секции
############################################################################
if ( $useSNATSection =~ /[Yy][Ee][Ss]/ ) {
   for ($i=0;$i<=$#snatSections;$i++) {
       $snatSections[$i] =~ s/[\r\n]*//g ;
       my($numSection,$fromIntName,$fromAddr,$toIntName,$toAddr,$allowRecord,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat,$is_collect_stat,$is_drop_default) = split(/&/, $snatSections[$i]) ;
       my(@allowRecordList) = split(/,/, $allowRecord) ;       
# ---- создать цепочку и зарулить туда трафик секции
       system "$ipt -N CHIN$statPrefix ; $ipt -N CHOUT$statPrefix ;" ;
       system "$ipt -A FORWARD -i $toIntName -o $fromIntName -s ! $fromAddr -d $fromAddr -j CHIN$statPrefix" ; 
       system "$ipt -A FORWARD -i $fromIntName -o $toIntName -s $fromAddr -d ! $fromAddr -j CHOUT$statPrefix" ;
# ---- запрет необработанного - из цепочки локальный траффик НЕ ВЫПУСКАЕТСЯ
# ---- это ограничение на уровне верха списка цепочек типа SNAT
       if ( $is_drop_default =~ /[Yy][Ee][Ss]/ ) {
          system "$ipt -A FORWARD -i $toIntName -o $fromIntName -s ! $fromAddr -d $fromAddr -j $drop_target" ; 
          system "$ipt -A FORWARD -i $fromIntName -o $toIntName -s $fromAddr -d ! $fromAddr -j $drop_target" ;
          }
# ---- разрешить icmp обмен
       if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
          system "$ipt -A CHIN$statPrefix -p icmp -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
          system "$ipt -A CHOUT$statPrefix -p icmp -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
          }
       system "$ipt -A CHIN$statPrefix -p icmp -j $accept_target" ;
       system "$ipt -A CHOUT$statPrefix -p icmp -j $accept_target" ;
# ---- если разрешено в конфиге - разрешить state:ESTABLISHED,RELATED CONNTRACK траффик
       if ( $isConntrackUse =~ /[Yy][Ee][Ss]/ ) { 
          if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
             system "$ipt -A CHIN$statPrefix -m state --state ESTABLISHED,RELATED -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
             system "$ipt -A CHOUT$statPrefix -m state --state ESTABLISHED,RELATED -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
             }
          system "$ipt -A CHIN$statPrefix -m state --state ESTABLISHED,RELATED -j $accept_target" ;
          system "$ipt -A CHOUT$statPrefix -m state --state ESTABLISHED,RELATED -j $accept_target" ;
          }
# ---- инициализация правил SNAT трансляции
       for ($m=0;$m<=$#allowRecordList;$m++) {
           my($ip,$proto,$port) = split(/#/, $allowRecordList[$m]) ;
           $ipin = "" ; $ipout = "" ; if ($ip ne "") { $ipin = "-s $ip"; $ipout = "-d $ip"; }
# -------- инициализировать счетчики разрешенного локального траффика с префиксом <имя>[in|out]accept
           if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
              if ( $proto =~ /tcp/i || $proto =~ /udp/i ) {
                 system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
                 system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j ULOG $options_tcp_udp_ULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
	         }
              else {
                   system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."inaccept\"" ;
                   system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outaccept\"" ;
	           }
              }
# -------- создать собственно правила
           system "$ipt -A CHIN$statPrefix -p $proto $ipin --source-port $port -j $accept_target" ;
           system "$ipt -A CHOUT$statPrefix -p $proto $ipout --destination-port $port -j $accept_target" ;
           }
# ---- запретить весь необработанный предидущими правилами цепочки траффик
       if ( $is_collect_stat =~ /[Yy][Ee][Ss]/ ) { 
          system "$ipt -A CHIN$statPrefix -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."indrop\"" ;
          system "$ipt -A CHOUT$statPrefix -j ULOG $optionsULOG --ulog-prefix=\"".$statPrefix."outdrop\"" ;
          }
       if ( $is_drop_default =~ /[Yy][Ee][Ss]/ ) { system "$ipt -A CHIN$statPrefix -j $drop_target ; $ipt -A CHOUT$statPrefix -j $drop_target" ; }
       system "$ipt -t nat -s $fromAddr -d ! $fromAddr -o $toIntName -A POSTROUTING -j MASQUERADE" ;    
       print "+ Инициализация SNAT цепочки правил траффика - $statPrefix\n" ;
       print LOGTARGET "[$logID] + Инициализация SNAT цепочки правил траффика - $statPrefix\n" ;
       }
   }

print "Отработал конфигуратор сетевого фильтра и статистики IP траффика\n" ;
print LOGTARGET "[$logID] Отработал конфигуратор сетевого фильтра и статистики IP траффика\n" ;
close(LOGTARGET) ;
