#!/usr/bin/perl


# --- Лицензионное соглашение (license coding UTF8, general language of license text - Russian)
# (C) Белонин Сергей Станиславович, 2005. Все права зарезервированы
# 1.1 Настоящая программа для ЭВМ (именуемые далее ПО), является объектом авторского права и защищена законами РФ и
# международными соглашениями о защите авторских прав. Автор и правообладатель - Белонин Сергей Станиславович, именуемый
# далее ПРАВООБЛАДАТЕЛЬ - посредством настоящего ДОГОВОРА определяет условия и допустимые границы использования ПО третьими
# лицами (именуемыми далее ЛИЦЕНЗИАТЫ). В случае, если ЛИЦЕНЗИАТ не принимает всех условий настоящего ДОГОВОРА, он не имеет
# права использовать ПО. Факт создания копии ПО подтверждает согласие ЛИЦЕНЗАТА с настоящим ДОГОВОРОМ
# 1.2 Все права на ПО остаются у ПРАВООБЛАДТЕЛЯ и ЛИЦЕНЗИАТ не претендует на них. Ничто в настоящем договоре не подтверждает
# полный или частичный отказ ПРАВООБЛАДАТЕЛЯ от прав на ПО. Что же касается прав на использование ПО, то ЛИЦЕНЗИАТ не
# получает никаких прав на использование ПО, за исключением явно предоставляемых настоящим ДОГОВОРОМ. В том числе, включая,
# но не ограничиваясь, ЛИЦЕНЗИАТУ ЗАПРЕЩЕНО:
# - воспроизводить ПО, за исключением явно указанных в настоящем ДОГОВОРЕ случаев и оговоренных Законами РФ случаев
# - распространять ПО
# - публиковать ПО полностью или частично
# - использовать ПО в коммерческих целях
# 1.3 Настоящая программа публикуется КАК ЕСТЬ, без каких либо гарантий и обязательств. ПРАВООБЛАДАТЕЛЬ не берет на себя
# никаких обязательств, и не предоставляет никаких гарантий, связанных ПО, в том числе относительно применимости ПО для
# каких либо целей. ПРАВООБЛАДАТЕЛЬ не несет никакой ответственности за использование или неиспользование ЛИЦЕНЗАТОМ ПО,
# а также не несет никакой ответственности за любые результаты или их отсутствие, связанные с использованием или
# неиспользованием ЛИЦЕНЗАТОМ ПО
# 1.4 ЛИЦЕНЗАТ имеет право знакомится с ПО в личных познавательных целях, а также распространять ссылки на ПО и
# ПРАВООБЛАДАТЕЛЯ. Распространение непосредственно ПО запрещено
# 1.5 ЛИЦЕНЗАТ, являющийся физическим лицом, имеет право безвозмездно сделать одну копию размещённого на сайте ПРАВООБЛАДАТЕЛЯ
# ПО - всех или части файлов ПО - на свой персональный компьютер, а также имеет право безвозмездно запускать скопированную
# таким образом копию ПО на своём персональном компьютере, за исключением копирования и запуска размещённого на сайте
# ПРАВООБЛАДАТЕЛЯ ПО с коммерческими целями. Копирование и запуск размещённого на сайте ПО с коммерческими целями 
# запрещены. При этом описанные в настоящем разделе копирование и запуск ПО ЛИЦЕНЗАТ производит исключительно на свой страх
# и риск. ПЛИЦЕНЗАТ принимает на себя всю ответственность за использование или неиспользование ПО. ЛИЦЕНЗАТ принимает на
# себя всю ответственность за любые результаты или их отсутствие, связанные с использованием или неиспользованием ПО
# 1.6 К ЛИЦЕНЗАТАМ - физическим лицам, означенным в пункте 1.5 приравниваются государственные учреждения дошкольного,
#  школьного начального, среднего общего и среднего специального образования Российской Федерации
# 1.7 ЛИЦЕНЗИАТ обязуется не наносить интересам ПРАВООБЛАДАТЕЛЯ какой либо урон и не ущемлять интересы ПРАВООБЛАДАТЕЛЯ каким
# либо образом, связанным с использованием или не использованием ПО, и результатов или их отсутствия использования или
# неиспользования ПО
# 1.8 В случае неоднозначностей, противоречий или непонимания, в результате которых интересы ПРАВООБЛАДАТЕЛЯ могут быть
# ущемлены, ЛИЦЕНЗИАТ обязан получить у ПРАВООБЛАДАТЕЯ письменное разъяснение и руководствоваться им при использовании ПО.
# До получения письменного разъяснения ЛИЦЕНЗАТ обязан воздержаться от использования ПО
# 1.9 Если какая либо часть настоящего ДОГОВОРА будет признана не соответствующей требованиям Законов Российской Федерации,
# все остальные части настоящего ДОГОВОРА не теряют своей силы
# 2.0 В остальном стороны руководствуются законодательством РФ, возникшие разногласия урегулируются в суде, правомочным
# разрешать возникшие разногласия, по выбору ПРАВООБЛАДАТЕЛЯ

# --- LICENSE (general language of license text - Russian)
# (C) Sergey S. Belonin, 2005. All rights reserved
# Attention ! This program are protected by law and international agreements.
# You can create one copy on you personal computer, and call this program for personal noncommercial goals,
#  like as education, on you personal computer.
# You can't modify this program, include it in you developers, public, redistribute this program.
# This program are published AS IS, without any warranty.
# If you don't agree with all - don't use this program

sub sztoint($) { my $data = $_[0] ; my $sztoint_result = "" ;
    for ($i=0;$i<length($data);$i++) { my $curr_enc_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i,1) ; $form_curr_char = sprintf "%03d", ord($curr_char) ; $sztoint_result = $sztoint_result . $form_curr_char ;
        }
    return $sztoint_result ;
    }

sub inttosz($) { my $data = $_[0] ; my $inttosz_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $curr_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i*3,3) ; $form_curr_char = sprintf "%c", $curr_char ; $inttosz_result = $inttosz_result . $form_curr_char ;
        }
    return $inttosz_result ;
    }

sub data_encode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $encrypt_result = "" ; my $form_curr_enc_char = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_enc_char = "" ; my $curr_enc_char = "" ; my $form_curr_enc_char = "" ;
        $work_curr_enc_char = substr($data,$i*3,3) + substr($key,$cnt_key_position*3,3) ;
        if ( $work_curr_enc_char >= 255 ) { $curr_enc_char = $work_curr_enc_char - 255 ; } else { $curr_enc_char = $work_curr_enc_char ; } 
        $form_curr_enc_char = sprintf "%03d", $curr_enc_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $encrypt_result = $encrypt_result . $form_curr_enc_char ;
        }
    return $encrypt_result ;
    }

sub data_decode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $decrypt_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_dec_char = "" ; my $curr_dec_char = "" ; my $form_curr_dec_char = "" ;
        $work_curr_dec_char = abs(substr($data,$i*3,3)) - abs(substr($key,$cnt_key_position*3,3)) ;
        if ( $work_curr_dec_char < 0 ) { $curr_dec_char = $work_curr_dec_char + 255 ; } 
        else { $curr_dec_char = $work_curr_dec_char ; } 
        $form_curr_dec_char = sprintf "%03d", $curr_dec_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $decrypt_result = $decrypt_result . $form_curr_dec_char ;
        }
    return $decrypt_result ;
    }

$softVersion = "ipstat.v.3.22" ;

$beforeTitle = '<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 STYLE="padding: 0; margin: 0; border: none;">
<TR><TD WIDTH="8pt"><IMG SRC="img/borders/topleftnavy3.gif"></TD><TD CLASS="theam"></TD>
<TD WIDTH="8pt"><IMG SRC="img/borders/toprightnavy3.gif"></TD></TR><TR><TD CLASS="theam">&nbsp;</TD>' ;
$afterTitle = '<TD CLASS="theam">&nbsp;</TD></TR><TR><TD WIDTH="8pt"><IMG SRC="img/borders/bottomleftnavy3.gif"></TD>
<TD CLASS="theam"></TD><TD WIDTH="8pt"><IMG SRC="img/borders/bottomrightnavy3.gif"></TD></TR></TABLE>' ;

sub fmtNumber($) { my($number) = $_[0] ; my($a1,$a2,$a3,$a4,$a5,$a6,$a7,$aEnd) ;
if ( $number =~ /(\w*)(\w{3,3})/ ) { $a1 = $2 ; $aEnd = $1 ; } else { $aEnd = $number ; }
if ( $number =~ /(\w*)(\w{3,3})(\w{3,3})/ ) { $a2 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{6,6})/ ) { $a3 = $2." " ; $aEnd = $1 ; }
if ( $number =~ /(\w*)(\w{3,3})(\w{9,9})/ ) { $a4 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{12,12})/ ) { $a5 = $2." " ; $aEnd = $1 ; }
if ( $number =~ /(\w*)(\w{3,3})(\w{15,15})/ ) { $a6 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{18,18})/ ) { $a7 = $2." " ; $aEnd = $1 ; }
if ( $aEnd ne "" ) { $aEnd .= " " ; } $result = "$aEnd$a7$a6$a5$a4$a3$a2$a1" ; }
# при необходимости - ввести выбранную дату (последний день месяца) в корректный диапазон
sub normalize_day($$$) { my($day) = $_[2] ;
    if (($_[0] % 4) == 0) { if ($_[1] == 2 && $_[2] > 29 ) { $day = 29 ; } } else { if ($_[1] == 2 && $_[2] > 28 ) { $day = 28 ; } }
    if (($_[1] == 4 || $_[1] == 6 || $_[1] == 9 || $_[1] == 11) && $_[2] > 30 ) { $day = 30 ; }
    return $day ; }

$PGPASSWORD = "cosiculspassword" ;
$ENV{PGPASSWORD} = $PGPASSWORD ;

############################################################################################################################
#                                                                                                                          #
# БЛОК РАСПАРСИВАНИЯ КОНФИГА МОДУЛЯ КОНФИГУРИРОВАНИЯ СЕТЕВОГО ФИЛЬТРА И СБОРА СТАТИСТИКИ О ПРОХОДЯЩЕМ ТРАФФИКЕ             #
#                                                                                                                          #
############################################################################################################################
$filtercfg = "/usr/local/cosiculs/etc/iprules.conf" ;
# обработать конфигурационный файл и перевести данные из читабельного формата в технологический
open(OPT, $filtercfg) || die "ОШИБКА. Не нахожу файла конфигурации !!!\n" ;
$numSection = 0 ;
while (<OPT>) {
# --- определить номер секции
      if ($_ =~ /^\s*\[.?[Ss][Tt][Aa][Rr][Tt].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; $typeSection = $1 ; $numSection = $2 ; }
      elsif ($_ =~ /^\s*\[.?[Ss][Tt][Oo][Pp].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; 
# --------- проверить на непересекаемость секции
            if ($2 ne $numSection || $1 ne $typeSection ) { die "ОШИБКА. Секции не должны пересекаться !!!" ; } 
# --------- инициализировать элемент списка массивом значений секции
	    else { 
	         if ($numSection eq "") { die "ОШИБКА. Не определена переменная numSection в заголовке текущей секции." ; }
                 if ($typeSection eq "") { die "ОШИБКА. Не определена переменная typeSection в заголовке текущей секции." ; }
# -------------- COMMON sections
                 if ( $typeSection =~ /[Cc][Oo][Mm][Mm][Oo][Nn]/ ) {
# ----------------- инициализировать общесистемные переменные
                    $pathIPTables = $section{pathIPTables} ;       if ($pathIPTables eq "") { die "ОШИБКА. Не определена переменная pathIPTables для текущей секции." ; }
                    $useSNATSection = $section{useSNATSection} ;   if ($useSNATSection eq "") { die "ОШИБКА. Не определена переменная useSNATSection для текущей секции." ; } 
                    $serverName = $section{serverName} ;           if ($serverName eq "") { die "ОШИБКА. Не определена переменная serverName для текущей секции." ; } 
                    $cityName = $section{cityName} ;               if ($cityName eq "") { die "ОШИБКА. Не определена переменная cityName для текущей секции." ; } 
                    $serverList = $section{serverList} ;           if ($serverList eq "") { die "ОШИБКА. Не определена переменная serverList для текущей секции." ; } 
                    $cityList = $section{cityList} ;               if ($cityList eq "") { die "ОШИБКА. Не определена переменная cityList для текущей секции." ; } 
                    $baseURL = $section{baseURL} ;                 if ($baseURL eq "") { die "ОШИБКА. Не определена переменная baseURL для текущей секции." ; } 
                    $confVersion = $section{confVersion} ;         if ($confVersion eq "") { die "ОШИБКА. Не определена переменная confVersion для текущей секции." ; } 
	            $isConntrackFtp = $section{isConntrackFtp} ;   if ($isConntrackFtp eq "") { die "ОШИБКА. Не определена переменная isConntrackFtp для текущей секции." ; }
                    $pathLog = $section{pathLog} ;                 if ($pathLog eq "") { die "ОШИБКА. Не определена переменная pathLog для текущей секции." ; } 
                    $ipt = $pathIPTables ; }		 
# -------------- SANITY sections
                 if ( $typeSection =~ /[Bb][Ll][Aa][Cc][Kk][Ll][Ii][Ss][Tt]/ ) {
	            $pathToList = $section{pathToList} ;           if ($pathToList eq "") { die "ОШИБКА. Не определена переменная pathToList для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ;           if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$pathToList."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $blacklistSections[$#blacklistSections+1] = $aaa ; }		 
# -------------- FILTER sections
                 if ( $typeSection =~ /[Ff][Ii][Ll][Tt][Ee][Rr]/ ) {
                    $intName = $section{intName}           ; if ($intName eq "") { die "ОШИБКА. Не определена переменная intName для текущей секции." ; }
# ----------------- флаг динамически инициализируемого интерфейса - если установлен, не используется IP
# ----------------- в списке антиспуфинга и в выделении типа траффика
                    $isDynInt = $section{isDynInt} ;               if ($isDynInt eq "") { die "ОШИБКА. Не определена переменная isDynInt для текущей секции." ; } 
	            $intIP = $section{intIP} ;                     if ($intIP eq "") { die "ОШИБКА. Не определена переменная intIP для текущей секции." ; }
	            $Network = $section{Network} ;                 if ($Network eq "") { die "ОШИБКА. Не определена переменная Network для текущей секции." ; }
	            $useBroadcast = $section{useBroadcast} ;       if ($useBroadcast eq "") { die "ОШИБКА. Не определена переменная useBroadcast для текущей секции." ; }
	            $ipBroadcast = $section{ipBroadcast} ;         if ($ipBroadcast eq "") { die "ОШИБКА. Не определена переменная ipBroadcast для текущей секции." ; }
	            $asServer = $section{asServer} ;               if ($asServer eq "") { die "ОШИБКА. Не определена переменная asServer для текущей секции." ; }
	            $asClient = $section{asClient} ;               if ($asClient eq "") { die "ОШИБКА. Не определена переменная intClient для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse} ;   if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ;           if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$intName."&".$isDynInt."&".$intIP."&".$Network."&".$useBroadcast."&".$ipBroadcast."&".$asServer."&".$asClient."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $filterSections[$#filterSections+1] = $aaa ; }		 
# -------------- SNAT sections
                 if ( $typeSection =~ /[Ss][Nn][Aa][Tt]/ ) {
                    $fromIntName = $section{fromIntName} ;         if ($fromIntName eq "") { die "ОШИБКА. Не определена переменная fromIntName для текущей секции." ; }
                    $fromAddr    = $section{fromAddr}    ;         if ($fromAddr eq "") { die "ОШИБКА. Не определена переменная fromAddr для текущей секции." ; }
                    $toIntName   = $section{toIntName}   ;         if ($toIntName eq "") { die "ОШИБКА. Не определена переменная toIntName для текущей секции." ; }
                    $toAddr      = $section{toAddr}      ;         if ($toAddr eq "") { die "ОШИБКА. Не определена переменная toAddr для текущей секции." ; }
	            $allowRecord = $section{allowRecord} ;         if ($allowRecord eq "") { die "ОШИБКА. Не определена переменная allowRecord для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse} ;   if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix  = $section{statPrefix}  ;         if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$fromIntName."&".$fromAddr."&".$toIntName."&".$toAddr."&".$allowRecord."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
                    $snatSections[$#snatSections+1] = $aaa ; }		 
		 undef($section) ;
	         }
	    }
# --- отфильтровать комментарии и пустые строки, выбрать значения
      else { if ($_ !~ /^[\s\t]*#.*/ && $_ !~ /^$/) { $_ =~ s/[\n\r]+//g ; if ( $_ !~ /.*statDescription.*/ ) { $_ =~ s/[\s\t]+//g ; } else { $_ =~ s/[\s\t]*statDescription[\s\t]*=/statDescription=/g ; } ($key,$value) = split (/=/, $_) ; $section{$key} = $value ; } }
      }
close(OPT) ;
if ( $#blacklistSections >= 1) { @blacklistSections = sort{$a <=> $b} @blacklistSections ; }
if ( $#filterSections >= 1) { @filterSections = sort{$a <=> $b} @filterSections ; }
if ( $#snatSections >= 1) { @snatSections = sort{$a <=> $b} @snatSections ; }
$cityList =~ s/[\s\r\n]*//g ; my(@filialslist) = split(/,/, $cityList) ;
$serverList =~ s/[\s\r\n]*//g ; my(@srvList) = split(/,/, $serverList) ;
############################################################################################################################
#                                                                                                                          #
# ЗАВЕРШЕНИЕ БЛОКА РАСПАРСИВАНИЯ КОНФИГА МОДУЛЯ КОНФИГУРИРОВАНИЯ СЕТЕВОГО ФИЛЬТРА И СБОРА СТАТИСТИКИ О ПРОХОДЯЩЕМ ТРАФФИКЕ #
#                                                                                                                          #
############################################################################################################################

# получить поля запроса
if ($ENV{REQUEST_METHOD} eq "POST") { if ($ENV{CONTENT_LENGTH} != 0) { sysread(STDIN,$rawRequest,$ENV{'CONTENT_LENGTH'}) ; my(@sz) = split ('\&', $rawRequest) ; for ($i=0; $i <= $#sz; $i++) { ($key, $value) = split ('=', $sz[$i]) ; $value =~ s/%([0-9a-hA-H]{2})/pack("C",hex($1))/ge ; $value =~ s/\+/ /g ; $value =~ s/[\n\r]*//g ; $request{$key} = $value ; } } }

print "Content-type: text/html\n\n" ;

print "<HTML><HEAD><BASE HREF=\"$baseURL\"><META HTTP-EQUIV=Content-Type content=\"text/html; charset=utf-8\">" ;
print "<META HTTP-EQUIV=Content-Script-Type content=\"text/javascript\"><META HTTP-EQUIV=\"Style-Type\" content=\"text/css\">" ;
print "<LINK REL=STYLESHEET HREF=\"$baseURL/css/frst2.css\"><TITLE>Статистика сетевого траффика</TITLE></HEAD><BODY>" ;
print "<STYLE> \n BODY { font-family: sans-serif; font-size: 9pt; } \n TD { vertical-align: top; } \n TD.tdhead { background-color: navy; color: white; } \n </STYLE>" ;

if ($ENV{CONTENT_LENGTH} <= 0)
   {
print <<STOPP1 ;
<STYLE>
BODY { font-family: sans-serif; font-size: 9pt; }
TD { vertical-align: top; }
TD.tdhead { background-color: navy; color: white; }
</STYLE>
<FORM METHOD="POST" ACTION="$baseURL/cgi/ipstat.cgi">
<TABLE WIDTH=100% ALIGN=center CELLPADDING="0" CELLSPACING="0">
<TR><TD>$beforeTitle <TD CLASS=\"title\">Статистика сетевого траффика</TD> $afterTitle </TD></TR>
<TR><TD>&nbsp;</TD></TR>

<TR><TD>
<TABLE BORDER="1" WIDTH="100%">
<TR><TD CLASS="tdhead">&nbsp;Включить секции</TD><TD CLASS="tdhead">&nbsp;Хронологические условия</TD></TR>
<TR><TD>
STOPP1

for ($i=0;$i<=$#blacklistSections;$i++) { $blacklistSections[$i] =~ s/[\r\n]*//g ; my($numSection,$pathToList,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $blacklistSections[$i]) ; print "<INPUT TYPE=\"checkbox\" NAME=\"select_condition_section_name_$statPrefix\">$statDescription<BR>" ; }
for ($i=0;$i<=$#filterSections;$i++) { $filterSections[$i] =~ s/[\r\n]*//g ; my($numSection,$intName,$isDynInt,$intIP,$Network,$useBroadcast,$ipBroadcast,$asServer,$asClient,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $filterSections[$i]) ; print "<INPUT TYPE=\"checkbox\" NAME=\"select_condition_section_name_$statPrefix\">$statDescription<BR>" ; }
for ($i=0;$i<=$#snatSections;$i++) { $snatSections[$i] =~ s/[\r\n]*//g ; my($numSection,$fromIntName,$fromAddr,$toIntName,$toAddr,$allowRecord,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $snatSections[$i]) ; print "<INPUT TYPE=\"checkbox\" NAME=\"select_condition_section_name_$statPrefix\">$statDescription<BR>" ; }

print <<STOPP3 ;
   </TD><TD WIDHT="100%">
   <INPUT TYPE="radio" NAME="select_datetime_agregate" VALUE="per_all" CHECKED>суммарно за выбранный период&nbsp;
   <BR><INPUT TYPE="radio" NAME="select_datetime_agregate" VALUE="per_month">развернуть по месяцам
   <BR><INPUT TYPE="radio" NAME="select_datetime_agregate" VALUE="per_day">развернуть по дням
   <HR><TABLE WIDHT="100%"><TR><TD COLSPAN="3" WIDTH="100%">
   <INPUT TYPE="radio" NAME="select_datetime_range" VALUE="through_current_year">Год&nbsp;<INPUT TYPE="radio" NAME="select_datetime_range" VALUE="through_current_month" CHECKED>Месяц&nbsp;<INPUT TYPE="radio" NAME="select_datetime_range" VALUE="through_current_day">День
   <BR><INPUT TYPE="radio" NAME="select_datetime_range" VALUE="through_manual_range">Диапазон дат:</TD></TR>
  <TR><TD>&nbsp;&nbsp;&nbsp;</TD><TD>с&nbsp;</TD><TD WIDTH="100%">
STOPP3

%monthsList = ( 1 => "января", 2 => "февраля", 3 => "марта", 4 => "апреля", 5 => "мая", 6 => "июня", 7 => "июля", 8 => "августа", 9 => "сентября", 10 => "октября", 11 => "ноября", 12 => "декабря") ;
$current_day = `date +%d` ; $current_day =~ s/[\r\n]+//g ; if ( $current_day =~ /0([0-9])/ ) { $current_day = $1 ; }
$current_month = `date +%m` ; $current_month =~ s/[\r\n]+//g ; if ( $current_month =~ /0([0-9])/ ) { $current_month = $1 ; } 
$current_year = `date +%Y` ; $current_year =~ s/[\r\n]+//g ;
print "<SELECT NAME=\"select_condition_from_range_day\" LENGHT=\"2\">" ; for ($i=1;$i<=31;$i++) { if ( $i == $current_day ) { print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }
print "</SELECT>/<SELECT NAME=\"select_condition_from_range_month\" LENGHT=\"2\">" ; for ($i=1;$i<=12;$i++) { if ( $i == $current_month ) { print "<OPTION VALUE=\"$i\" SELECTED>$monthsList{$i}" ; } else { print "<OPTION VALUE=\"$i\">$monthsList{$i}" ; } }
print "</SELECT>/<SELECT NAME=\"select_condition_from_range_year\" LENGHT=\"4\">" ; for ($i=2000;$i<=2100;$i++) { if ( $i == $current_year ) { print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }
print "</SELECT></TD></TR><TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD>по&nbsp;</TD><TD>" ;

print "<SELECT NAME=\"select_condition_to_range_day\" LENGHT=\"2\">" ; for ($i=1;$i<=31;$i++) { if ( $i == $current_day ) { print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }
print "</SELECT>/<SELECT NAME=\"select_condition_to_range_month\" LENGHT=\"2\">" ; for ($i=1;$i<=12;$i++) { if ( $i == $current_month ) { print "<OPTION VALUE=\"$i\" SELECTED>$monthsList{$i}" ; } else { print "<OPTION VALUE=\"$i\">$monthsList{$i}" ; } }
print "</SELECT>/<SELECT NAME=\"select_condition_to_range_year\" LENGHT=\"4\">" ; for ($i=2000;$i<=2100;$i++) { if ( $i == $current_year ) {  print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }

print <<STOPP2 ;
    </SELECT>
   </TR></TABLE>
</TD></TR>

<TR><TD CLASS="tdhead">&nbsp;Условия по протоколам</TD>

<TD CLASS="tdhead">&nbsp;Дополнительные условия</TD></TR>
<TR><TD>
 <INPUT TYPE="checkbox" NAME="select_checker_protocols_agregate">развернуть по протоколам (иначе суммарно)
 <HR><INPUT TYPE="checkbox" NAME="select_checker_protocols_list">выбрать протоколы
 <BR>&nbsp;&nbsp;&nbsp;<INPUT TYPE="checkbox" NAME="select_checker_protocol_tcp" CHECKED>учитывать TCP
 <BR>&nbsp;&nbsp;&nbsp;<INPUT TYPE="checkbox" NAME="select_checker_protocol_udp" CHECKED>учитывать UDP 
 <BR>&nbsp;&nbsp;&nbsp;<INPUT TYPE="checkbox" NAME="select_checker_protocol_icmp" CHECKED>учитывать ICMP 
</TD>

<TD ROWSPAN="5">
 <INPUT TYPE="checkbox" NAME="view_input_traffic" CHECKED>Показывать входящий траффик 
 <BR><INPUT TYPE="checkbox" NAME="view_output_traffic" CHECKED>Показывать исходящий траффик
 <HR><INPUT TYPE="checkbox" NAME="view_allow_traffic" CHECKED>Показывать разрешенный траффик
 <BR><INPUT TYPE="checkbox" NAME="view_drop_traffic" CHECKED>Показывать запрещенный траффик
 <HR><INPUT TYPE="checkbox" NAME="view_ip_descriptions"><A HREF="">Показывать описание IP адресов</A>
 <BR><INPUT TYPE="checkbox" NAME="view_sql_query">Показывать текст SQL запроса 
 <HR>&nbsp;Условия и последовательность сортировки:<BR><BR>
 <TABLE>
  <TR><TD>сначала по:</TD><TD><SELECT NAME="order_1_field">
   <OPTION VALUE="per_none">не сортировать<OPTION VALUE="ip_totlen">размеру<OPTION VALUE="ip_addr_source">IP отправителя<OPTION VALUE="ip_addr_destination">IP получателя<OPTION VALUE="port_source">порту отправителя<OPTION VALUE="port_destination">порту получателя<OPTION VALUE="ip_protocol">протоколу<OPTION VALUE="ulog_record_timestamp">дате
   </SELECT><INPUT TYPE="checkbox" NAME="order_1_descending" CHECKED>по убыванию</TD></TR>
  <TR><TD>далее по:</TD><TD><SELECT NAME="order_2_field">
   <OPTION VALUE="per_none">не сортировать<OPTION VALUE="ip_totlen">размеру<OPTION VALUE="ip_addr_source">IP отправителя<OPTION VALUE="ip_addr_destination">IP получателя<OPTION VALUE="port_source">порту отправителя<OPTION VALUE="port_destination">порту получателя<OPTION VALUE="ip_protocol">протоколу<OPTION VALUE="ulog_record_timestamp">дате
   </SELECT><INPUT TYPE="checkbox" NAME="order_2_descending" CHECKED>по убыванию
  </TD></TR> 
  <TR><TD>далее по:</TD><TD><SELECT NAME="order_3_field">
   <OPTION VALUE="per_none">не сортировать<OPTION VALUE="ip_totlen">размеру<OPTION VALUE="ip_addr_source">IP отправителя<OPTION VALUE="ip_addr_destination">IP получателя<OPTION VALUE="port_source">порту отправителя<OPTION VALUE="port_destination">порту получателя<OPTION VALUE="ip_protocol">протоколу<OPTION VALUE="ulog_record_timestamp">дате
   </SELECT><INPUT TYPE="checkbox" NAME="order_3_descending" CHECKED>по убыванию  
  </TD></TR>
  <TR><TD>далее по:</TD><TD><SELECT NAME="order_4_field">
   <OPTION VALUE="per_none">не сортировать<OPTION VALUE="ip_totlen">размеру<OPTION VALUE="ip_addr_source">IP отправителя<OPTION VALUE="ip_addr_destination">IP получателя<OPTION VALUE="port_source">порту отправителя<OPTION VALUE="port_destination">порту получателя<OPTION VALUE="ip_protocol">протоколу<OPTION VALUE="ulog_record_timestamp">дате
   </SELECT><INPUT TYPE="checkbox" NAME="order_4_descending" CHECKED>по убыванию</TD></TR>
  <TR><TD>далее по:</TD><TD><SELECT NAME="order_5_field">
   <OPTION VALUE="per_none">не сортировать<OPTION VALUE="ip_totlen">размеру<OPTION VALUE="ip_addr_source">IP отправителя<OPTION VALUE="ip_addr_destination">IP получателя<OPTION VALUE="port_source">порту отправителя<OPTION VALUE="port_destination">порту получателя<OPTION VALUE="ip_protocol">протоколу<OPTION VALUE="ulog_record_timestamp">дате
   </SELECT><INPUT TYPE="checkbox" NAME="order_5_descending" CHECKED>по убыванию</TD></TR>
 </TABLE>
</TD></TR>

<TR><TD CLASS="tdhead">&nbsp;Условия по IP адресам</TD></TR>
<TR><TD><TABLE WIDTH="100%">
 <TR><TD COLSPAN="3"><INPUT TYPE="checkbox" NAME="select_checker_src_ips_agregate">развернуть по src IP<INPUT TYPE="checkbox" NAME="select_checker_dst_ips_agregate">развернуть по dst IP<HR></TD></TR>
 <TR><TD><INPUT TYPE="checkbox" NAME="select_checker_src_ip">где SRC IP = </TD><TD><INPUT TYPE="input" NAME="select_condition_src_ip"></TD><TD><INPUT TYPE="radio" NAME="select_conditions_ip_summator" VALUE="AND" CHECKED>И</TD></TR>
 <TR><TD><INPUT TYPE="checkbox" NAME="select_checker_dst_ip">где DST IP = </TD><TD><INPUT TYPE="input" NAME="select_condition_dst_ip"></TD><TD><INPUT TYPE="radio" NAME="select_conditions_ip_summator" VALUE="OR">ИЛИ</TD></TR></TABLE>
</TD></TR>

<TR><TD CLASS="tdhead">&nbsp;Условия по портам</TD></TR>
<TR><TD><TABLE WIDTH="100%">
 <TR><TD COLSPAN="3"><INPUT TYPE="checkbox" NAME="select_checker_src_ports_agregate">развернуть по порту src<INPUT TYPE="checkbox" NAME="select_checker_dst_ports_agregate">развернуть по порту dst<HR></TD></TR>
 <TR><TD><INPUT TYPE="checkbox" NAME="select_checker_src_port">где SRC port = </TD><TD><SELECT NAME="select_conditions_src_port_protocol"><OPTION VALUE="6" SELECTED>tcp<OPTION VALUE="17">udp</SELECT>:<INPUT TYPE="input" LENGHT="5" SIZE="5" NAME="select_conditions_src_port"></TD><TD><INPUT TYPE="radio" NAME="select_conditions_port_summator" VALUE="AND" CHECKED>И</TD></TR>
 <TR><TD><INPUT TYPE="checkbox" NAME="select_checker_dst_port">где DST port = </TD><TD><SELECT NAME="select_conditions_dst_port_protocol"><OPTION VALUE="6" SELECTED>tcp<OPTION VALUE="17">udp</SELECT>:<INPUT TYPE="input" LENGHT="5" SIZE="5" NAME="select_conditions_dst_port"></TD><TD><INPUT TYPE="radio" NAME="select_conditions_port_summator" VALUE="OR">ИЛИ</TD></TR></TABLE>
</TD></TR>
<TR><TD COLSPAN=4 ALIGN=center><BR><input TYPE="submit" Value="Выполнить  запрос"><input TYPE="reset" Value="Отменить выполнение"><BR>&nbsp;</TD></TR>
</TABLE>

</TD></TR></TABLE>
</FORM>
</BODY></HTML>
STOPP2
   }
else
   {
   print '<TABLE WIDTH=100% ALIGN=center CELLPADDING="0" CELLSPACING="0">' ;
   print "<TR><TD>$beforeTitle <TD CLASS=\"title\">Статистика сетевого траффика</TD> $afterTitle </TD></TR>" ;
   print '<TR><TD>&nbsp;</TD></TR></TABLE>' ;
# - сформировать запрос SQL
# - объявить переменные
   $sql_query = "" ; $sql_query_select_strings = "" ; $sql_query_from_string = "ulog_summator" ; $sql_query_where_string = "" ; $sql_query_group_string = "" ; $sql_query_order_string = "" ;

# ---- определить отмеченные для обработки секции, если секции не определены - вывести уведомление и не формировать запрос
   @requestKeys = keys %request ; @selected_section_prefixes = () ; for ($i=0;$i<=$#requestKeys;$i++) { if ( $requestKeys[$i] =~ /select_condition_section_name_(\S+)/ ) { $selected_section_prefixes[$#selected_section_prefixes + 1] = $1 ; } }
   if ( $#selected_section_prefixes < 0 ) { print "Запрос не сформирован, обработка не проведена. Причина - должна быть выбрана хотя бы одна конфигурационная секция сетевого фильтра для обработки !!!<BR>" ; }
   else {
# ----- обработать условия выбора секций и учета видов траффика
        $sql_query_where_section_and_traffic_type = "" ;
        for ($i=0;$i<=$#selected_section_prefixes;$i++) { 
	    if ( $request{view_input_traffic} eq "on" ) {
               if ( $request{view_allow_traffic} eq "on" ) { if ( $sql_query_where_section_and_traffic_type ne "" ) { $sql_query_where_section_and_traffic_type .= " OR " ; }  $sql_query_where_section_and_traffic_type .= "ulog_prefix = '$selected_section_prefixes[$i]"."inaccept'" ; }
	       if ( $request{view_drop_traffic} eq "on" ) { if ( $sql_query_where_section_and_traffic_type ne "" ) { $sql_query_where_section_and_traffic_type .= " OR " ; }  $sql_query_where_section_and_traffic_type .= "ulog_prefix = '$selected_section_prefixes[$i]"."indrop'" ; }
	       }
	    if ( $request{view_output_traffic} eq "on" ) {
               if ( $request{view_allow_traffic} eq "on" ) { if ( $sql_query_where_section_and_traffic_type ne "" ) { $sql_query_where_section_and_traffic_type .= " OR " ; }  $sql_query_where_section_and_traffic_type .= "ulog_prefix = '$selected_section_prefixes[$i]"."outaccept'" ; }
	       if ( $request{view_drop_traffic} eq "on" ) { if ( $sql_query_where_section_and_traffic_type ne "" ) { $sql_query_where_section_and_traffic_type .= " OR " ; }  $sql_query_where_section_and_traffic_type .= "ulog_prefix = '$selected_section_prefixes[$i]"."outdrop'" ; }
               }
	    }
# ----- обработать условия времени
        $sql_query_where_datetime_range = "" ;
        if ( $request{select_datetime_range} eq "through_current_year" ) { $current_year = `date +%Y` ; $current_year =~ s/[\r\n]+//g ; $sql_query_where_datetime_range = "ulog_record_timestamp BETWEEN '$current_year-1-1 00:00:00' AND '$current_year-12-31 23:59:59'" ; }
        if ( $request{select_datetime_range} eq "through_current_month" ) { $current_year = `date +%Y` ; $current_year =~ s/[\r\n]+//g ; $current_month = `date +%m` ; $current_month =~ s/[\r\n]+//g ;
           $current_day = normalize_day($current_year,$current_month,31) ; $sql_query_where_datetime_range = "ulog_record_timestamp BETWEEN '$current_year-$current_month-1 00:00:00' AND '$current_year-$current_month-$current_day 23:59:59'" ; }
        if ( $request{select_datetime_range} eq "through_current_day" ) { $current_year_and_month_and_day = `date +%Y-%m-%d` ; $current_year_and_month_and_day =~ s/[\r\n]+//g ; $sql_query_where_datetime_range = "ulog_record_timestamp BETWEEN '$current_year_and_month_and_day 00:00:00' AND '$current_year_and_month_and_day 23:59:59'" ; }
        if ( $request{select_datetime_range} eq "through_manual_range" ) { $request{select_condition_from_range_day} = normalize_day($request{select_condition_from_range_year},$request{select_condition_from_range_month},$request{select_condition_from_range_day}) ; $request{select_condition_to_range_day} = normalize_day($request{select_condition_to_range_year},$request{select_condition_to_range_month},$request{select_condition_to_range_day}) ;
	   $sql_query_where_datetime_range = "ulog_record_timestamp BETWEEN '$request{select_condition_from_range_year}-$request{select_condition_from_range_month}-$request{select_condition_from_range_day} 00:00:00' AND '$request{select_condition_to_range_year}-$request{select_condition_to_range_month}-$request{select_condition_to_range_day} 23:59:59'" ; }
        if ( $sql_query_where_string ne "" ) { $sql_query_where_string .= " AND"; } $sql_query_where_string .= $sql_query_where_datetime_range ;
        if ( $request{select_datetime_agregate} eq "per_month" ) { $sql_query_select_string .= ", DATE_TRUNC('month', ulog_record_timestamp) as ulog_record_timestamp" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "DATE_TRUNC('month', ulog_record_timestamp)" ; }
        if ( $request{select_datetime_agregate} eq "per_day" ) { $sql_query_select_string .= ", DATE_TRUNC('day', ulog_record_timestamp) as ulog_record_timestamp" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "DATE_TRUNC('day', ulog_record_timestamp)" ; }

# ----- обработать условия протоколов
        if ( $request{select_checker_protocols_agregate} eq "on" ) { $sql_query_select_string .= ", ip_protocol" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "ip_protocol" ; }
        $sql_query_where_protocols_list = "" ;
        if ( $request{select_checker_protocols_list} eq "on" ) { 
	   if ( $request{select_checker_protocol_tcp} eq "on" ) { if ( $sql_query_where_protocols_list ne "" ) { $sql_query_where_protocols_list .= " OR" ; } $sql_query_where_protocols_list .= " ip_protocol = 6" ; }
	   if ( $request{select_checker_protocol_udp} eq "on" ) { if ( $sql_query_where_protocols_list ne "" ) { $sql_query_where_protocols_list .= " OR" ; } $sql_query_where_protocols_list .= " ip_protocol = 17" ; }	   
	   if ( $request{select_checker_protocol_icmp} eq "on" ) { if ( $sql_query_where_protocols_list ne "" ) { $sql_query_where_protocols_list .= " OR" ; } $sql_query_where_protocols_list .= " ip_protocol = 1" ; }
           if ( $sql_query_where_string ne "" ) { $sql_query_where_string .= " AND" ; } $sql_query_where_string .= " ( $sql_query_where_protocols_list )" ; }

# ----- обработать условия IP адресов
        if ( $request{select_checker_src_ips_agregate} eq "on" ) { $sql_query_select_string .= ", ip_addr_source" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "ip_addr_source" ; }
        if ( $request{select_checker_dst_ips_agregate} eq "on" ) { $sql_query_select_string .= ", ip_addr_destination" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "ip_addr_destination" ; }
        if ( $request{select_checker_src_ip} eq "on" && $request{select_checker_dst_ip} eq "on" ) { $sql_query_where_string .= " AND ((ip_addr_source = '$request{select_condition_src_ip}') $request{select_conditions_ip_summator} (ip_addr_destination = '$request{select_condition_dst_ip}'))" ; }
        else { if ( $request{select_checker_src_ip} eq "on" ) { $sql_query_where_string .= " AND ip_addr_source = '$request{select_condition_src_ip}'" ; } if ( $request{select_checker_dst_ip} eq "on" ) { $sql_query_where_string .= " AND ip_addr_destination = '$request{select_condition_dst_ip}'" ; } }

# ----- обработать условия портов
        if ( $request{select_checker_protocols_agregate} ne "on" && ( $request{select_checker_src_ports_agregate} eq "on" || $request{select_checker_dst_ports_agregate} eq "on") ) {  $sql_query_select_string .= ", ip_protocol" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "ip_protocol" ; }
        if ( $request{select_checker_src_ports_agregate} eq "on" ) { $sql_query_select_string .= ", port_source" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "port_source" ; }
        if ( $request{select_checker_dst_ports_agregate} eq "on" ) { $sql_query_select_string .= ", port_destination" ; if ( $sql_query_group_string ne "" ) { $sql_query_group_string .= ", " ; } $sql_query_group_string .= "port_destination" ; }
        if ( $request{select_checker_src_port} eq "on" && $request{select_checker_dst_port} eq "on" ) { $sql_query_where_string .= " AND ((ip_protocol = $request{select_conditions_src_port_protocol} AND port_source = $request{select_conditions_src_port}) $request{select_conditions_port_summator} (ip_protocol = $request{select_conditions_dst_port_protocol} AND port_destination = $request{select_conditions_dst_port}))" ; }
        else { if ( $request{select_checker_src_port} eq "on" ) { $sql_query_where_string .= " AND (ip_protocol = $request{select_conditions_src_port_protocol} AND port_source = $request{select_conditions_src_port})" ; } if ( $request{select_checker_dst_port} eq "on" ) { $sql_query_where_string .= " AND (ip_protocol = $request{select_conditions_dst_port_protocol} AND port_destination = $request{select_conditions_dst_port})" ; } }

# ----- обработать условия показа описаний IP адресов

# ----- обработать условия сортировки
        if ( $request{order_1_field} ne "per_none" ) { if ($sql_query_order_string ne "") { $sql_query_order_string .= ", " ; } $sql_query_order_string .= $request{order_1_field} ; if ( $request{order_1_descending} ne "on" ) { $sql_query_order_string .= " ASC" ; } else { $sql_query_order_string .= " DESC" ; } }
        if ( $request{order_2_field} ne "per_none" ) { if ($sql_query_order_string ne "") { $sql_query_order_string .= ", " ; } $sql_query_order_string .= $request{order_2_field} ; if ( $request{order_2_descending} ne "on" ) { $sql_query_order_string .= " ASC" ; } else { $sql_query_order_string .= " DESC" ; } }
        if ( $request{order_3_field} ne "per_none" ) { if ($sql_query_order_string ne "") { $sql_query_order_string .= ", " ; } $sql_query_order_string .= $request{order_3_field} ; if ( $request{order_3_descending} ne "on" ) { $sql_query_order_string .= " ASC" ; } else { $sql_query_order_string .= " DESC" ; } }
        if ( $request{order_4_field} ne "per_none" ) { if ($sql_query_order_string ne "") { $sql_query_order_string .= ", " ; } $sql_query_order_string .= $request{order_4_field} ; if ( $request{order_4_descending} ne "on" ) { $sql_query_order_string .= " ASC" ; } else { $sql_query_order_string .= " DESC" ; } }
        if ( $request{order_5_field} ne "per_none" ) { if ($sql_query_order_string ne "") { $sql_query_order_string .= ", " ; } $sql_query_order_string .= $request{order_5_field} ; if ( $request{order_5_descending} ne "on" ) { $sql_query_order_string .= " ASC" ; } else { $sql_query_order_string .= " DESC" ; } }

# ----- собрать строку SQL запроса
        $sql_query = "SELECT SUM(ip_totlen) AS ip_totlen $sql_query_select_string FROM $sql_query_from_string WHERE ($sql_query_where_section_and_traffic_type) AND $sql_query_where_string" ;
        if ( $sql_query_group_string ne "" ) { $sql_query .= " GROUP BY " . $sql_query_group_string ; }
        if ( $sql_query_order_string ne "" ) { $sql_query .= " ORDER BY " . $sql_query_order_string ; }
        $sql_query .= " ;" ;
        if ( $request{view_sql_query} ) { print "<HR COLOR=\"navy\"><BR><FONT COLOR=\"navy\"><B>Справочно - по результатам работы сформирован следующий SQL запрос:</B></FONT><BR><BR> $sql_query<BR>&nbsp;<HR COLOR=\"navy\">" ; }
# ----- обработать SQL запрос и вывеси результат
	@resultSQL = `psql -U cosiculs -d cosiculs -A -h 127.0.0.1 -c \"$sql_query\"` ;
# ----- вычислить порядок следования полей для вывода в предопределенном порядке и дальнейшей обработки
        $resultSQL[0] =~ s/[\r\n]+//g ; @headers = split(/\|/, $resultSQL[0]) ; 
	my(%headersIndex) = ("ip_addr_source" => "none", "port_source" => "none", "ip_addr_destination" => "none", "port_destination" => "none", "ip_protocol" => "none", "ulog_record_timestamp" => "none", "ip_totlen" => "none" ) ;
        my(%headersTitle) = ("ip_addr_source" => "IP адрес&nbsp;<BR>&nbsp;отправителя", "port_source" => "Порт&nbsp;<BR>&nbsp;отправителя", "ip_addr_destination" => "IP адрес&nbsp;<BR>&nbsp;получателя", "port_destination" => "Порт&nbsp;<BR>&nbsp;получателя", "ip_protocol" => "Протокол", "ulog_record_timestamp" => "Дата", "ip_totlen" => "Значение счетчика,&nbsp;<BR>&nbsp;байт" ) ;
        my(%protocolsTitle) = ("1" => "icmp", "6" => "tcp", "17" => "udp" ) ;
	for ($i=0;$i<=$#headers;$i++) { 
	    if ( $headers[$i] eq "ip_addr_source" ) { $headersIndex{ip_addr_source} = $i ; } if ( $headers[$i] eq "port_source" ) { $headersIndex{port_source} = $i ; } if ( $headers[$i] eq "ip_addr_destination" ) { $headersIndex{ip_addr_destination} = $i ; } if ( $headers[$i] eq "port_destination" ) { $headersIndex{port_destination} = $i ; }
	    if ( $headers[$i] eq "ip_protocol" ) { $headersIndex{ip_protocol} = $i ; } if ( $headers[$i] eq "ulog_record_timestamp" ) { $headersIndex{ulog_record_timestamp} = $i ; } if ( $headers[$i] eq "ip_totlen" ) { $headersIndex{ip_totlen} = $i ; } }
        print "<BR><TABLE BORDER=\"1\" WIDTH=\"100%\">" ;
        $summaBytes = 0 ;
        for ($i=0;$i<=$#resultSQL-1;$i++) {
            $resultSQL[$i] =~ s/[\r\n]+//g ; @currStrResultSQL = split(/\|/, $resultSQL[$i]) ; print "<TR>" ;
	    if ( $headersIndex{ulog_record_timestamp} ne "none" ) { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{ulog_record_timestamp}&nbsp;</TD>" ; } 
	    else { $currStrResultSQL[$headersIndex{ulog_record_timestamp}] =~ /(\S+)-(\S+)-(\S+)\s\S+:\S+:\S+.*/ ; if ( $request{select_datetime_agregate} eq "per_month" ) { print "<TD ALIGN=\"left\">&nbsp;$1-$2&nbsp;</TD>" ; } else { print "<TD ALIGN=\"left\">&nbsp;$1-$2-$3&nbsp;</TD>" ; } } }
	    if ( $headersIndex{ip_protocol} ne "none" ) { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{ip_protocol}&nbsp;</TD>" ; } else { if ( $currStrResultSQL[$headersIndex{ip_protocol}] == 1 ||  $currStrResultSQL[$headersIndex{ip_protocol}] == 6 ||  $currStrResultSQL[$headersIndex{ip_protocol}] == 17 ) { print "<TD ALIGN=\"left\">&nbsp;$protocolsTitle{$currStrResultSQL[$headersIndex{ip_protocol}]}&nbsp;</TD>" ; } else { print "<TD ALIGN=\"left\">&nbsp;$protocolsTitle{$currStrResultSQL[$headersIndex{ip_protocol}]}&nbsp;</TD>" ; } } }
	    if ( $headersIndex{ip_addr_source} ne "none" ) { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{ip_addr_source}&nbsp;</TD>" ; } else { print "<TD ALIGN=\"left\">&nbsp;$currStrResultSQL[$headersIndex{ip_addr_source}]&nbsp;</TD>" ; } }
	    if ( $headersIndex{port_source} ne "none" )  { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{port_source}&nbsp;</TD>" ; } else { print "<TD ALIGN=\"right\">&nbsp;$currStrResultSQL[$headersIndex{port_source}]&nbsp;</TD>" ; } } 
	    if ( $headersIndex{ip_addr_destination} ne "none" ) { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{ip_addr_destination}&nbsp;</TD>" ; } else { print "<TD ALIGN=\"left\">&nbsp;$currStrResultSQL[$headersIndex{ip_addr_destination}]&nbsp;</TD>" ; } }
	    if ( $headersIndex{port_destination} ne "none" )  { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{port_destination}&nbsp;</TD>" ; } else { print "<TD ALIGN=\"right\">&nbsp;$currStrResultSQL[$headersIndex{port_destination}]&nbsp;</TD>" ; } }
	    if ( $headersIndex{ip_totlen} ne "none" ) { if ( $i == 0 ) { print "<TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;$headersTitle{ip_totlen}&nbsp;</TD>" ; } else { my($fmtNum) = fmtNumber($currStrResultSQL[$headersIndex{ip_totlen}]) ; print "<TD ALIGN=\"right\">&nbsp;$fmtNum&nbsp;</TD>" ; $summaBytes += $currStrResultSQL[$headersIndex{ip_totlen}] ; } } 
            print "</TR>" ;
	    }
        if ($#headers != 0 ) {  my($fmtNum) = fmtNumber($summaBytes) ;print "<TR><TD COLSPAN=\"$#headers\">&nbsp;Итого</TD><TD ALIGN=\"right\">&nbsp;$fmtNum&nbsp;</TD></TR></TABLE>" ; }
	else { print "</TABLE>" ; }
        }
   print '<BR>&nbsp;<HR COLOR=\"navy\"></BODY></HTML>' ;
   }
