#!/usr/bin/perl


# --- Лицензионное соглашение (license coding UTF8, general language of license text - Russian)
# (C) Белонин Сергей Станиславович, 2005. Все права зарезервированы
# 1.1 Настоящая программа для ЭВМ (именуемые далее ПО), является объектом авторского права и защищена законами РФ и
# международными соглашениями о защите авторских прав. Автор и правообладатель - Белонин Сергей Станиславович, именуемый
# далее ПРАВООБЛАДАТЕЛЬ - посредством настоящего ДОГОВОРА определяет условия и допустимые границы использования ПО третьими
# лицами (именуемыми далее ЛИЦЕНЗИАТЫ). В случае, если ЛИЦЕНЗИАТ не принимает всех условий настоящего ДОГОВОРА, он не имеет
# права использовать ПО. Факт создания копии ПО подтверждает согласие ЛИЦЕНЗАТА с настоящим ДОГОВОРОМ
# 1.2 Все права на ПО остаются у ПРАВООБЛАДТЕЛЯ и ЛИЦЕНЗИАТ не претендует на них. Ничто в настоящем договоре не подтверждает
# полный или частичный отказ ПРАВООБЛАДАТЕЛЯ от прав на ПО. Что же касается прав на использование ПО, то ЛИЦЕНЗИАТ не
# получает никаких прав на использование ПО, за исключением явно предоставляемых настоящим ДОГОВОРОМ. В том числе, включая,
# но не ограничиваясь, ЛИЦЕНЗИАТУ ЗАПРЕЩЕНО:
# - воспроизводить ПО, за исключением явно указанных в настоящем ДОГОВОРЕ случаев и оговоренных Законами РФ случаев
# - распространять ПО
# - публиковать ПО полностью или частично
# - использовать ПО в коммерческих целях
# 1.3 Настоящая программа публикуется КАК ЕСТЬ, без каких либо гарантий и обязательств. ПРАВООБЛАДАТЕЛЬ не берет на себя
# никаких обязательств, и не предоставляет никаких гарантий, связанных ПО, в том числе относительно применимости ПО для
# каких либо целей. ПРАВООБЛАДАТЕЛЬ не несет никакой ответственности за использование или неиспользование ЛИЦЕНЗАТОМ ПО,
# а также не несет никакой ответственности за любые результаты или их отсутствие, связанные с использованием или
# неиспользованием ЛИЦЕНЗАТОМ ПО
# 1.4 ЛИЦЕНЗАТ имеет право знакомится с ПО в личных познавательных целях, а также распространять ссылки на ПО и
# ПРАВООБЛАДАТЕЛЯ. Распространение непосредственно ПО запрещено
# 1.5 ЛИЦЕНЗАТ, являющийся физическим лицом, имеет право безвозмездно сделать одну копию размещённого на сайте ПРАВООБЛАДАТЕЛЯ
# ПО - всех или части файлов ПО - на свой персональный компьютер, а также имеет право безвозмездно запускать скопированную
# таким образом копию ПО на своём персональном компьютере, за исключением копирования и запуска размещённого на сайте
# ПРАВООБЛАДАТЕЛЯ ПО с коммерческими целями. Копирование и запуск размещённого на сайте ПО с коммерческими целями 
# запрещены. При этом описанные в настоящем разделе копирование и запуск ПО ЛИЦЕНЗАТ производит исключительно на свой страх
# и риск. ПЛИЦЕНЗАТ принимает на себя всю ответственность за использование или неиспользование ПО. ЛИЦЕНЗАТ принимает на
# себя всю ответственность за любые результаты или их отсутствие, связанные с использованием или неиспользованием ПО
# 1.6 К ЛИЦЕНЗАТАМ - физическим лицам, означенным в пункте 1.5 приравниваются государственные учреждения дошкольного,
#  школьного начального, среднего общего и среднего специального образования Российской Федерации
# 1.7 ЛИЦЕНЗИАТ обязуется не наносить интересам ПРАВООБЛАДАТЕЛЯ какой либо урон и не ущемлять интересы ПРАВООБЛАДАТЕЛЯ каким
# либо образом, связанным с использованием или не использованием ПО, и результатов или их отсутствия использования или
# неиспользования ПО
# 1.8 В случае неоднозначностей, противоречий или непонимания, в результате которых интересы ПРАВООБЛАДАТЕЛЯ могут быть
# ущемлены, ЛИЦЕНЗИАТ обязан получить у ПРАВООБЛАДАТЕЯ письменное разъяснение и руководствоваться им при использовании ПО.
# До получения письменного разъяснения ЛИЦЕНЗАТ обязан воздержаться от использования ПО
# 1.9 Если какая либо часть настоящего ДОГОВОРА будет признана не соответствующей требованиям Законов Российской Федерации,
# все остальные части настоящего ДОГОВОРА не теряют своей силы
# 2.0 В остальном стороны руководствуются законодательством РФ, возникшие разногласия урегулируются в суде, правомочным
# разрешать возникшие разногласия, по выбору ПРАВООБЛАДАТЕЛЯ

# --- LICENSE (general language of license text - Russian)
# (C) Sergey S. Belonin, 2005. All rights reserved
# Attention ! This program are protected by law and international agreements.
# You can create one copy on you personal computer, and call this program for personal noncommercial goals,
#  like as education, on you personal computer.
# You can't modify this program, include it in you developers, public, redistribute this program.
# This program are published AS IS, without any warranty.
# If you don't agree with all - don't use this program

sub sztoint($) { my $data = $_[0] ; my $sztoint_result = "" ;
    for ($i=0;$i<length($data);$i++) { my $curr_enc_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i,1) ; $form_curr_char = sprintf "%03d", ord($curr_char) ; $sztoint_result = $sztoint_result . $form_curr_char ;
        }
    return $sztoint_result ;
    }

sub inttosz($) { my $data = $_[0] ; my $inttosz_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $curr_char = "" ; my $form_curr_char = "" ;    
        $curr_char = substr($data,$i*3,3) ; $form_curr_char = sprintf "%c", $curr_char ; $inttosz_result = $inttosz_result . $form_curr_char ;
        }
    return $inttosz_result ;
    }

sub data_encode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $encrypt_result = "" ; my $form_curr_enc_char = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_enc_char = "" ; my $curr_enc_char = "" ; my $form_curr_enc_char = "" ;
        $work_curr_enc_char = substr($data,$i*3,3) + substr($key,$cnt_key_position*3,3) ;
        if ( $work_curr_enc_char >= 255 ) { $curr_enc_char = $work_curr_enc_char - 255 ; } else { $curr_enc_char = $work_curr_enc_char ; } 
        $form_curr_enc_char = sprintf "%03d", $curr_enc_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $encrypt_result = $encrypt_result . $form_curr_enc_char ;
        }
    return $encrypt_result ;
    }

sub data_decode($$) { my $data = $_[0] ; my $key = $_[1] ; my $cnt_key_position = 0 ; my $decrypt_result = "" ;
    for ($i=0;$i<length($data)/3;$i++) { my $work_curr_dec_char = "" ; my $curr_dec_char = "" ; my $form_curr_dec_char = "" ;
        $work_curr_dec_char = abs(substr($data,$i*3,3)) - abs(substr($key,$cnt_key_position*3,3)) ;
        if ( $work_curr_dec_char < 0 ) { $curr_dec_char = $work_curr_dec_char + 255 ; } 
        else { $curr_dec_char = $work_curr_dec_char ; } 
        $form_curr_dec_char = sprintf "%03d", $curr_dec_char ;
        $cnt_key_position++ ; if ( $cnt_key_position >= length($key)/3 ) { $cnt_key_position = 0 ; } ;    
        $decrypt_result = $decrypt_result . $form_curr_dec_char ;
        }
    return $decrypt_result ;
    }

#####################################################################################
# Скрипт запроса статистики потребленного внешнего траффика
#####################################################################################
$softVersion = "ipstat_reports.v.3.22" ;
$dtStamp = `date "+%Y-%m-%d %H:%M:%S"` ; $dtStamp =~ s/[\r\n\t]*//g ; $host = `hostname` ; $host =~ s/[\r\n\t]*//g ; $logID = $host . " " . $dtStamp ; 
# баг - любой месяц считается по 31 число, но пока катит
$currYear = `date +%Y` ; $currYear =~ s/[\r\n\t]*//g ; $currMonth = `date +%m` ; $currMonth =~ s/[\r\n\t]*//g ; 
$prevYear = $currYear ; if ( $currMonth == 1 ) { $prevMonth = 12 ; $prevYear = $currYear - 1 ; } else { $prevMonth = $currMonth -1 ; }

$counter_input_allow = 0 ; $counter_input_drop = 0 ; $counter_output_allow = 0 ; $counter_output_drop = 0 ; $counter_input = 0 ; $counter_output = 0 ;

$beforeTitle = '<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 STYLE="padding: 0; margin: 0; border: none;">
<TR><TD WIDTH="8pt"><IMG SRC="img/borders/topleftnavy3.gif"></TD><TD CLASS="theam"></TD>
<TD WIDTH="8pt"><IMG SRC="img/borders/toprightnavy3.gif"></TD></TR><TR><TD CLASS="theam">&nbsp;</TD>' ;
$afterTitle = '<TD CLASS="theam">&nbsp;</TD></TR><TR><TD WIDTH="8pt"><IMG SRC="img/borders/bottomleftnavy3.gif"></TD>
<TD CLASS="theam"></TD><TD WIDTH="8pt"><IMG SRC="img/borders/bottomrightnavy3.gif"></TD></TR></TABLE>' ;

$PGPASSWORD = "cosiculspassword" ;
$ENV{PGPASSWORD} = $PGPASSWORD ;
@request_result = ("") ; check_hasp() ;

sub fmtNumber($) { my($number) = $_[0] ; my($a1,$a2,$a3,$a4,$a5,$a6,$a7,$aEnd) ; if ( $number =~ /(\w*)(\w{3,3})/ ) { $a1 = $2 ; $aEnd = $1 ; } else { $aEnd = $number ; } if ( $number =~ /(\w*)(\w{3,3})(\w{3,3})/ ) { $a2 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{6,6})/ ) { $a3 = $2." " ; $aEnd = $1 ; }
    if ( $number =~ /(\w*)(\w{3,3})(\w{9,9})/ ) { $a4 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{12,12})/ ) { $a5 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{15,15})/ ) { $a6 = $2." " ; $aEnd = $1 ; } if ( $number =~ /(\w*)(\w{3,3})(\w{18,18})/ ) { $a7 = $2." " ; $aEnd = $1 ; } if ( $aEnd ne "" ) { $aEnd .= " " ; } $result = "$aEnd$a7$a6$a5$a4$a3$a2$a1" ; }
# при необходимости - ввести выбранную дату (последний день месяца) в корректный диапазон
sub normalize_day($$$) { my($day) = $_[2] ;
    if (($_[0] % 4) == 0) { if ($_[1] == 2 && $_[2] > 29 ) { $day = 29 ; } } else { if ($_[1] == 2 && $_[2] > 28 ) { $day = 28 ; } }
    if (($_[1] == 4 || $_[1] == 6 || $_[1] == 9 || $_[1] == 11) && $_[2] > 30 ) { $day = 30 ; }
    return $day ; }

# сформировать список секций, участвующих в выборке, и собственно подстроки SQL WHERE условий
# а также сформировать хэш описания секций
%section_description ;
sub get_section_where_substring($) {
    my $intext_section_type = $_[0] ; my $sql_where_section_prefix = "" ; 
    for ($i=0;$i<=$#blacklistSections;$i++) { $blacklistSections[$i] =~ s/[\r\n]*//g ; my($numSection,$pathToList,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $blacklistSections[$i]) ; $section_description{$statPrefix} = $statDescription ;
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) { if ( $sql_where_section_prefix ne "" ) { $sql_where_section_prefix .= " OR " ; } 
	   $sql_where_section_prefix .= " (ulog_prefix = '$statPrefix"."inaccept' OR ulog_prefix = '$statPrefix"."indrop' OR ulog_prefix = '$statPrefix"."outaccept' OR ulog_prefix = '$statPrefix"."outdrop')" ; } }
    for ($i=0;$i<=$#filterSections;$i++) { $filterSections[$i] =~ s/[\r\n]*//g ; my($numSection,$intName,$isDynInt,$intIP,$Network,$useBroadcast,$ipBroadcast,$asServer,$asClient,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $filterSections[$i]) ; $section_description{$statPrefix} = $statDescription ;
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) { if ( $sql_where_section_prefix ne "" ) { $sql_where_section_prefix .= " OR " ; } 
	   $sql_where_section_prefix .= " (ulog_prefix = '$statPrefix"."inaccept' OR ulog_prefix = '$statPrefix"."indrop' OR ulog_prefix = '$statPrefix"."outaccept' OR ulog_prefix = '$statPrefix"."outdrop')" ; } }
    for ($i=0;$i<=$#snatSections;$i++) { $snatSections[$i] =~ s/[\r\n]*//g ; my($numSection,$fromIntName,$fromAddr,$toIntName,$toAddr,$allowRecord,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $snatSections[$i]) ; $section_description{$statPrefix} = $statDescription ;
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) { if ( $sql_where_section_prefix ne "" ) { $sql_where_section_prefix .= " OR " ; } 
	   $sql_where_section_prefix .= " (ulog_prefix = '$statPrefix"."inaccept' OR ulog_prefix = '$statPrefix"."indrop' OR ulog_prefix = '$statPrefix"."outaccept' OR ulog_prefix = '$statPrefix"."outdrop')" ; } }
    $return = $sql_where_section_prefix ; }

sub calc_and_view_per_section_stat($$$) { my $intext_section_type = $_[0] ; my $start_date_range = $_[1] ; my $stop_date_range = $_[2] ; 
    my $sql_where_section_prefix = get_section_where_substring($intext_section_type) ;
    $sql_query_text = "SELECT section_name,
                              SUM(inaccept) AS inaccept, 
			      SUM(indrop) AS indrop, 
			      SUM(outaccept) AS outaccept, 
			      SUM(outdrop) AS outdrop 
		       FROM ( SELECT ulog_record_timestamp, 
		                     replace(replace(replace(replace(ulog_prefix,'inaccept',''),'indrop',''),'outaccept',''),'outdrop','') AS section_name, 
                                     ip_addr_source, ip_addr_destination, 
				     CASE WHEN $select_in_accept_per_counters_prefix THEN ip_totlen ELSE 0 END AS inaccept, 
				     CASE WHEN $select_in_drop_per_counters_prefix THEN ip_totlen ELSE 0 END AS indrop, 
				     CASE WHEN $select_out_accept_per_counters_prefix THEN ip_totlen ELSE 0 END AS outaccept, 
				     CASE WHEN $select_out_drop_per_counters_prefix THEN ip_totlen ELSE 0 END AS outdrop 
			       FROM ulog_summator 
			       WHERE ulog_record_timestamp BETWEEN '".$start_date_range."' AND '".$stop_date_range."' 
			             AND ($sql_where_section_prefix)) tmp GROUP BY section_name;" ;
    if ( $request{is_sql_query_view} eq "on" ) { print "<HR COLOR=\"navy\">$sql_query_text<BR><HR COLOR=\"navy\"><BR>" ; }
    @resultQueryText = `psql -U cosiculs -d cosiculs -A -t -h 127.0.0.1 -c \"$sql_query_text\"` ;
    $counter_input_allow = 0 ; $counter_input_drop = 0 ; $counter_output_allow = 0 ; $counter_output_drop = 0 ; $counter_input = 0 ; $counter_output = 0 ;
    $fmt_counter_input_allow = 0 ; $fmt_counter_input_drop = 0 ; $fmt_counter_output_allow = 0 ; $fmt_counter_output_drop = 0 ; $fmt_counter_input = 0 ; $fmt_counter_output = 0 ;
    print "<TABLE BORDER=\"1\" WIDTH=\"100%\">" ;
    print "<TR><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Секция&nbsp;<BR>&nbsp;конфигуратора&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD></TR>\n" ;
    for ($i=0;$i<=$#resultQueryText;$i++) { $resultQueryText[$i] =~ s/[\r\n]*//g ; my($section_prefix,$counter_inaccept,$counter_indrop,$counter_outaccept,$counter_outdrop) = split(/\|/, $resultQueryText[$i]) ;
        $counter_input_allow += $counter_inaccept ; $fmt_counter_inaccept = fmtNumber($counter_inaccept) ; $counter_input_drop += $counter_indrop ; $fmt_counter_indrop = fmtNumber($counter_indrop) ;
        $counter_output_allow += $counter_outaccept ; $fmt_counter_outaccept = fmtNumber($counter_outaccept) ; $counter_output_drop += $counter_outdrop ; $fmt_counter_outdrop = fmtNumber($counter_outdrop) ;
        print "<TR><TD ALIGN=\"left\">&nbsp;$section_description{$section_prefix}&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_inaccept&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_indrop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_outaccept&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_outdrop&nbsp;</TD></TR>" ; }
    $counter_input = $counter_input_allow + $counter_input_drop ; $counter_output = $counter_output_allow + $counter_output_drop ;
    $fmt_counter_input_allow = fmtNumber($counter_input_allow) ; $fmt_counter_input_drop = fmtNumber($counter_input_drop) ; $fmt_counter_output_allow = fmtNumber($counter_output_allow) ; $fmt_counter_output_drop = fmtNumber($counter_output_drop) ; $fmt_counter_input = fmtNumber($counter_input) ; $fmt_counter_output = fmtNumber($counter_output) ; 
    print "<TR><TD ALIGN=\"left\" ROWSPAN=\"2\">&nbsp;Итого&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_drop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_drop&nbsp;</TD></TR>" ;
    print "<TR><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_input&nbsp;</TD><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_output&nbsp;</TD></TR>" ;
    print "</TABLE><BR>" ; }

sub calc_and_view_per_ip_stat($$$) {  my $intext_section_type = $_[0] ; my $start_date_range = $_[1] ; my $end_date_range = $_[2] ; 
    $section_where_substring = get_section_where_substring($intext_section_type) ;
# - перебрать полученный список, запросить суммарные данные для каждого значения по видам траффика и вывести данные
    print "<TABLE BORDER=\"1\" WIDTH=\"100%\">" ;
    print "<TR><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;IP адрес&nbsp;<BR>&nbsp;хоста - &nbsp;<BR>&nbsp;корреспондента&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;на сервер&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;на сервер&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;с сервера&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;с сервера&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD></TR>\n" ;
    $counter_input_allow = 0 ; $counter_input_drop = 0 ; $counter_output_allow = 0 ; $counter_output_drop = 0 ; $counter_input = 0 ; $counter_output = 0 ;
    $fmt_counter_input_allow = 0 ; $fmt_counter_input_drop = 0 ; $fmt_counter_output_allow = 0 ; $fmt_counter_output_drop = 0 ; $fmt_counter_input = 0 ; $fmt_counter_output = 0 ;
    $sql_query_text = "SELECT CASE WHEN $select_in_per_counters_prefix THEN ip_addr_source 
			           WHEN $select_out_per_counters_prefix THEN ip_addr_destination END as ip_addr, 
				   SUM(CASE WHEN $select_in_accept_per_counters_prefix THEN ip_totlen ELSE 0 END) AS inaccept, 
				   SUM(CASE WHEN $select_in_drop_per_counters_prefix THEN ip_totlen ELSE 0 END) AS indrop, 
				   SUM(CASE WHEN $select_out_accept_per_counters_prefix THEN ip_totlen ELSE 0 END) AS outaccept, 
				   SUM(CASE WHEN $select_out_drop_per_counters_prefix THEN ip_totlen ELSE 0 END) AS outdrop 
		       FROM ulog_summator WHERE ulog_record_timestamp BETWEEN '$start_date_range' AND '$end_date_range' AND ($section_where_substring) GROUP BY ip_addr ORDER BY ip_addr ;" ;
    if ( $request{is_sql_query_view} eq "on" ) { print "<HR COLOR=\"navy\">$sql_query_text<BR><HR COLOR=\"navy\"><BR>" ; }
    @result_per_ip_query = `psql -U cosiculs -d cosiculs -A -t -h 127.0.0.1 -c \"$sql_query_text\"` ;
    for ($i=0;$i<=$#result_per_ip_query;$i++) { $result_per_ip_query[$i] =~ s/[\r\n\t]+//g ;
        my($result_per_ip_address,$result_per_ip_inallow,$result_per_ip_indrop,$result_per_ip_outallow,$result_per_ip_outdrop) = split (/\|/, $result_per_ip_query[$i]) ;
        $counter_input_allow += $result_per_ip_inallow ; $fmt_counter_input_allow = fmtNumber($result_per_ip_inallow) ;
        $counter_input_drop += $result_per_ip_indrop ; $fmt_counter_input_drop = fmtNumber($result_per_ip_indrop) ;
        $counter_output_allow += $result_per_ip_outallow ; $fmt_counter_output_allow = fmtNumber($result_per_ip_outallow) ;
        $counter_output_drop += $result_per_ip_outdrop ; $fmt_counter_output_drop = fmtNumber($result_per_ip_outdrop) ;
        print "<TR><TD ALIGN=\"left\">&nbsp;$result_per_ip_address&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_drop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_drop&nbsp;</TD></TR>" ;
        }
    $counter_input = $counter_input_allow + $counter_input_drop ; $counter_output = $counter_output_allow + $counter_output_drop ;
    $fmt_counter_input_allow = fmtNumber($counter_input_allow) ; $fmt_counter_input_drop = fmtNumber($counter_input_drop) ; $fmt_counter_output_allow = fmtNumber($counter_output_allow) ; $fmt_counter_output_drop = fmtNumber($counter_output_drop) ; $fmt_counter_input = fmtNumber($counter_input) ; $fmt_counter_output = fmtNumber($counter_output) ; 
    print "<TR><TD ALIGN=\"left\" ROWSPAN=\"2\">&nbsp;Итого&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_drop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_drop&nbsp;</TD></TR>" ;
    print "<TR><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_input&nbsp;</TD><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_output&nbsp;</TD></TR>" ;
    print "</TABLE><BR>" ; }

sub calc_and_view_per_date_stat($$$) { my $intext_section_type = $_[0] ; my $start_date_range = $_[1] ; my $stop_date_range = $_[2] ; 
    my $sql_where_section_prefix = get_section_where_substring($intext_section_type) ;
    $sql_query_text = "SELECT DATE_TRUNC('day',ulog_record_timestamp) AS record_date,
                              SUM(inaccept) AS inaccept, 
			      SUM(indrop) AS indrop, 
			      SUM(outaccept) AS outaccept, 
			      SUM(outdrop) AS outdrop 
		       FROM ( SELECT ulog_record_timestamp, 
		                     replace(replace(replace(replace(ulog_prefix,'inaccept',''),'indrop',''),'outaccept',''),'outdrop','') AS section_name, 
                                     ip_addr_source, ip_addr_destination, 
				     CASE WHEN $select_in_accept_per_counters_prefix THEN ip_totlen ELSE 0 END AS inaccept, 
				     CASE WHEN $select_in_drop_per_counters_prefix THEN ip_totlen ELSE 0 END AS indrop, 
				     CASE WHEN $select_out_accept_per_counters_prefix THEN ip_totlen ELSE 0 END AS outaccept, 
				     CASE WHEN $select_out_drop_per_counters_prefix THEN ip_totlen ELSE 0 END AS outdrop 
			      FROM ulog_summator 
			      WHERE ulog_record_timestamp BETWEEN '".$start_date_range."' AND '".$stop_date_range."' 
			            AND ($sql_where_section_prefix)) tmp 
			      GROUP BY record_date ORDER BY record_date;" ;
    if ( $request{is_sql_query_view} eq "on" ) { print "<HR COLOR=\"navy\">$sql_query_text<BR><HR COLOR=\"navy\"><BR>" ; }
    @resultQueryText = `psql -U cosiculs -d cosiculs -A -t -h 127.0.0.1 -c \"$sql_query_text\"` ;
    $counter_input_allow = 0 ; $counter_input_drop = 0 ; $counter_output_allow = 0 ; $counter_output_drop = 0 ; $counter_input = 0 ; $counter_output = 0 ;
    $fmt_counter_input_allow = 0 ; $fmt_counter_input_drop = 0 ; $fmt_counter_output_allow = 0 ; $fmt_counter_output_drop = 0 ; $fmt_counter_input = 0 ; $fmt_counter_output = 0 ;
    print "<TABLE BORDER=\"1\" WIDTH=\"100%\">" ;
    print "<TR><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Дата&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Входящий&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;разрешенный&nbsp;</TD><TD CLASS=\"tdhead\" ALIGN=\"center\">&nbsp;Исходящий&nbsp;<BR>&nbsp;запрещенный&nbsp;</TD></TR>\n" ;
    for ($i=0;$i<=$#resultQueryText;$i++) { $resultQueryText[$i] =~ s/[\r\n]*//g ; my($record_date,$counter_inaccept,$counter_indrop,$counter_outaccept,$counter_outdrop) = split(/\|/, $resultQueryText[$i]) ;
        $counter_input_allow += $counter_inaccept ; $fmt_counter_inaccept = fmtNumber($counter_inaccept) ; $counter_input_drop += $counter_indrop ; $fmt_counter_indrop = fmtNumber($counter_indrop) ;
        $counter_output_allow += $counter_outaccept ; $fmt_counter_outaccept = fmtNumber($counter_outaccept) ; $counter_output_drop += $counter_outdrop ; $fmt_counter_outdrop = fmtNumber($counter_outdrop) ;
        $record_date =~ s/00:00:00//g ;
	print "<TR><TD ALIGN=\"left\">&nbsp;$record_date&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_inaccept&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_indrop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_outaccept&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_outdrop&nbsp;</TD></TR>" ; }
    $counter_input = $counter_input_allow + $counter_input_drop ; $counter_output = $counter_output_allow + $counter_output_drop ;
    $fmt_counter_input_allow = fmtNumber($counter_input_allow) ; $fmt_counter_input_drop = fmtNumber($counter_input_drop) ; $fmt_counter_output_allow = fmtNumber($counter_output_allow) ; $fmt_counter_output_drop = fmtNumber($counter_output_drop) ; $fmt_counter_input = fmtNumber($counter_input) ; $fmt_counter_output = fmtNumber($counter_output) ; 
    print "<TR><TD ALIGN=\"left\" ROWSPAN=\"2\">&nbsp;Итого&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_input_drop&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_allow&nbsp;</TD><TD ALIGN=\"right\">&nbsp;$fmt_counter_output_drop&nbsp;</TD></TR>" ;
    print "<TR><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_input&nbsp;</TD><TD ALIGN=\"right\" COLSPAN=\"2\">&nbsp;$fmt_counter_output&nbsp;</TD></TR>" ;
    print "</TABLE><BR>" ; }
   
############################################################################################################################
#                                                                                                                          #
# БЛОК РАСПАРСИВАНИЯ КОНФИГА МОДУЛЯ КОНФИГУРИРОВАНИЯ СЕТЕВОГО ФИЛЬТРА И СБОРА СТАТИСТИКИ О ПРОХОДЯЩЕМ ТРАФФИКЕ             #
#                                                                                                                          #
############################################################################################################################
$filtercfg = "/usr/local/cosiculs/etc/iprules.conf" ;
# обработать конфигурационный файл и перевести данные из читабельного формата в технологический
open(OPT, $filtercfg) || die "ОШИБКА. Не нахожу файла конфигурации !!!\n" ;
$numSection = 0 ;
while (<OPT>) {
# --- определить номер секции
      if ($_ =~ /^\s*\[.?[Ss][Tt][Aa][Rr][Tt].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; $typeSection = $1 ; $numSection = $2 ; }
      elsif ($_ =~ /^\s*\[.?[Ss][Tt][Oo][Pp].(\S+.\w+).?\].*/) { $tmp = $1 ; $tmp =~ /(\S+).(\w+)/ ; 
# --------- проверить на непересекаемость секции
            if ($2 ne $numSection || $1 ne $typeSection ) { die "ОШИБКА. Секции не должны пересекаться !!!" ; } 
# --------- инициализировать элемент списка массивом значений секции
	    else { 
	         if ($numSection eq "") { die "ОШИБКА. Не определена переменная numSection в заголовке текущей секции." ; }
                 if ($typeSection eq "") { die "ОШИБКА. Не определена переменная typeSection в заголовке текущей секции." ; }
# -------------- COMMON sections
                 if ( $typeSection =~ /[Cc][Oo][Mm][Mm][Oo][Nn]/ ) {
# ----------------- инициализировать общесистемные переменные
                    $pathIPTables = $section{pathIPTables} ;       if ($pathIPTables eq "") { die "ОШИБКА. Не определена переменная pathIPTables для текущей секции." ; }
                    $useSNATSection = $section{useSNATSection} ;   if ($useSNATSection eq "") { die "ОШИБКА. Не определена переменная useSNATSection для текущей секции." ; } 
                    $serverName = $section{serverName} ;           if ($serverName eq "") { die "ОШИБКА. Не определена переменная serverName для текущей секции." ; } 
                    $cityName = $section{cityName} ;               if ($cityName eq "") { die "ОШИБКА. Не определена переменная cityName для текущей секции." ; } 
                    $serverList = $section{serverList} ;           if ($serverList eq "") { die "ОШИБКА. Не определена переменная serverList для текущей секции." ; } 
                    $cityList = $section{cityList} ;               if ($cityList eq "") { die "ОШИБКА. Не определена переменная cityList для текущей секции." ; } 
                    $baseURL = $section{baseURL} ;                 if ($baseURL eq "") { die "ОШИБКА. Не определена переменная baseURL для текущей секции." ; } 
                    $confVersion = $section{confVersion} ;         if ($confVersion eq "") { die "ОШИБКА. Не определена переменная confVersion для текущей секции." ; } 
	            $isConntrackFtp = $section{isConntrackFtp} ;   if ($isConntrackFtp eq "") { die "ОШИБКА. Не определена переменная isConntrackFtp для текущей секции." ; }
                    $pathLog = $section{pathLog} ;                 if ($pathLog eq "") { die "ОШИБКА. Не определена переменная pathLog для текущей секции." ; } 
                    $ipt = $pathIPTables ; }		 
# -------------- SANITY sections
                 if ( $typeSection =~ /[Bb][Ll][Aa][Cc][Kk][Ll][Ii][Ss][Tt]/ ) {
	            $pathToList = $section{pathToList} ;           if ($pathToList eq "") { die "ОШИБКА. Не определена переменная pathToList для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ;           if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$pathToList."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $blacklistSections[$#blacklistSections+1] = $aaa ; }		 
# -------------- FILTER sections
                 if ( $typeSection =~ /[Ff][Ii][Ll][Tt][Ee][Rr]/ ) {
                    $intName = $section{intName}           ; if ($intName eq "") { die "ОШИБКА. Не определена переменная intName для текущей секции." ; }
# ----------------- флаг динамически инициализируемого интерфейса - если установлен, не используется IP
# ----------------- в списке антиспуфинга и в выделении типа траффика
                    $isDynInt = $section{isDynInt} ;               if ($isDynInt eq "") { die "ОШИБКА. Не определена переменная isDynInt для текущей секции." ; } 
	            $intIP = $section{intIP} ;                     if ($intIP eq "") { die "ОШИБКА. Не определена переменная intIP для текущей секции." ; }
	            $Network = $section{Network} ;                 if ($Network eq "") { die "ОШИБКА. Не определена переменная Network для текущей секции." ; }
	            $useBroadcast = $section{useBroadcast} ;       if ($useBroadcast eq "") { die "ОШИБКА. Не определена переменная useBroadcast для текущей секции." ; }
	            $ipBroadcast = $section{ipBroadcast} ;         if ($ipBroadcast eq "") { die "ОШИБКА. Не определена переменная ipBroadcast для текущей секции." ; }
	            $asServer = $section{asServer} ;               if ($asServer eq "") { die "ОШИБКА. Не определена переменная asServer для текущей секции." ; }
	            $asClient = $section{asClient} ;               if ($asClient eq "") { die "ОШИБКА. Не определена переменная intClient для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse} ;   if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix = $section{statPrefix} ;           if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$intName."&".$isDynInt."&".$intIP."&".$Network."&".$useBroadcast."&".$ipBroadcast."&".$asServer."&".$asClient."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
# ----------------- инициализировать очередной элемент массива параметров
                    $filterSections[$#filterSections+1] = $aaa ; }		 
# -------------- SNAT sections
                 if ( $typeSection =~ /[Ss][Nn][Aa][Tt]/ ) {
                    $fromIntName = $section{fromIntName} ;         if ($fromIntName eq "") { die "ОШИБКА. Не определена переменная fromIntName для текущей секции." ; }
                    $fromAddr    = $section{fromAddr}    ;         if ($fromAddr eq "") { die "ОШИБКА. Не определена переменная fromAddr для текущей секции." ; }
                    $toIntName   = $section{toIntName}   ;         if ($toIntName eq "") { die "ОШИБКА. Не определена переменная toIntName для текущей секции." ; }
                    $toAddr      = $section{toAddr}      ;         if ($toAddr eq "") { die "ОШИБКА. Не определена переменная toAddr для текущей секции." ; }
	            $allowRecord = $section{allowRecord} ;         if ($allowRecord eq "") { die "ОШИБКА. Не определена переменная allowRecord для текущей секции." ; }
	            $isConntrackUse = $section{isConntrackUse} ;   if ($isConntrackUse eq "") { die "ОШИБКА. Не определена переменная isConntrackUse для текущей секции." ; }
	            $statPrefix  = $section{statPrefix}  ;         if ($statPrefix eq "") { die "ОШИБКА. Не определена переменная statPrefix для текущей секции." ; }
	            $statDescription = $section{statDescription} ; if ($statDescription eq "") { die "ОШИБКА. Не определена переменная statDescription для текущей секции." ; }
	            $isIncExtStat = $section{isIncExtStat} ;       if ($isIncExtStat eq "") { die "ОШИБКА. Не определена переменная isIncExtStat для текущей секции." ; }
	            $isIncIntStat = $section{isIncIntStat} ;       if ($isIncIntStat eq "") { die "ОШИБКА. Не определена переменная isIncIntStat для текущей секции." ; }
                    $aaa = $numSection."&".$fromIntName."&".$fromAddr."&".$toIntName."&".$toAddr."&".$allowRecord."&".$isConntrackUse."&".$statPrefix."&".$statDescription."&".$isIncIntStat."&".$isIncExtStat."\n\n" ;
                    $snatSections[$#snatSections+1] = $aaa ; }		 
		 undef($section) ;
	         }
	    }
# --- отфильтровать комментарии и пустые строки, выбрать значения
      else { if ($_ !~ /^[\s\t]*#.*/ && $_ !~ /^$/) { $_ =~ s/[\n\r]+//g ; if ( $_ !~ /.*statDescription.*/ ) { $_ =~ s/[\s\t]+//g ; } else { $_ =~ s/[\s\t]*statDescription[\s\t]*=/statDescription=/g ; } ($key,$value) = split (/=/, $_) ; $section{$key} = $value ; } }
      }
close(OPT) ;
if ( $#blacklistSections >= 1) { @blacklistSections = sort{$a <=> $b} @blacklistSections ; }
if ( $#filterSections >= 1) { @filterSections = sort{$a <=> $b} @filterSections ; }
if ( $#snatSections >= 1) { @snatSections = sort{$a <=> $b} @snatSections ; }
$cityList =~ s/[\s\r\n]*//g ; my(@filialslist) = split(/,/, $cityList) ;
$serverList =~ s/[\s\r\n]*//g ; my(@srvList) = split(/,/, $serverList) ;
############################################################################################################################
#                                                                                                                          #
# ЗАВЕРШЕНИЕ БЛОКА РАСПАРСИВАНИЯ КОНФИГА МОДУЛЯ КОНФИГУРИРОВАНИЯ СЕТЕВОГО ФИЛЬТРА И СБОРА СТАТИСТИКИ О ПРОХОДЯЩЕМ ТРАФФИКЕ #
#                                                                                                                          #
############################################################################################################################

# получить поля запроса
if ($ENV{REQUEST_METHOD} eq "POST") { if ($ENV{CONTENT_LENGTH} != 0) { 
   sysread(STDIN,$rawRequest,$ENV{'CONTENT_LENGTH'}) ; my(@sz) = split ('\&', $rawRequest) ;
   for ($i=0; $i <= $#sz; $i++) { ($key, $value) = split ('=', $sz[$i]) ;
        $value =~ s/%([0-9a-hA-H]{2})/pack("C",hex($1))/ge ; $value =~ s/\+/ /g ;
        $value =~ s/[\n\r]*//g ; $request{$key} = $value ; } } }

print "Content-type: text/html\n\n" ;
print "<HTML><HEAD><BASE HREF=\"$baseURL\"><META HTTP-EQUIV=Content-Type content=\"text/html; charset=utf-8\">" ;
print "<META HTTP-EQUIV=Content-Script-Type content=\"text/javascript\"><META HTTP-EQUIV=\"Style-Type\" content=\"text/css\">";
print "<LINK REL=STYLESHEET HREF=\"$baseURL/css/frst2.css\">" ;
print "<TITLE>Статистика сетевого траффика</TITLE></HEAD><BODY>" ;
print "<STYLE> \n BODY { font-family: sans-serif; font-size: 9pt; } \n TD { vertical-align: top; } \n TD.tdhead { background-color: navy; color: white; } \n </STYLE>" ;
print "<TABLE CELLSPACING=0 CELLPADDING=0 WIDTH=100% ALIGN=center><TR><TD>$beforeTitle <TD CLASS=\"title\">Статистика сетевого траффика</TD> $afterTitle </TD></TR><TR><TD HEIGHT=\"2pt\"></TD></TR></TABLE>" ;   
print "<TABLE CELLSPACING=0 CELLPADDING=0 BORDER=\"0\" WIDTH=\"100%\"><TR><TD COLSPAN=\"2\">$beforeTitle<TD CLASS=\"hdr\">Типовые статистические отчёты</TD>$afterTitle</TD></TR><TR><TD COLSPAN=\"2\"><BR></TD></TR></TABLE>";

if ($ENV{CONTENT_LENGTH} <= 0) {
   print "<FORM METHOD=\"POST\" ACTION=\"$baseURL/cgi/ipstat_reports.cgi\">" ;
   print "<TABLE BORDER=\"1\" WIDTH=\"100%\" BORDERCOLOR=\"navy\"><TR><TD CLASS=\"tdhead\" ALIGN=\"center\">Тип траффика</TD><TD CLASS=\"tdhead\" ALIGN=\"center\" COLSPAN=\"2\">Диапазон дат</TD></TR><TR><TD>" ;
   print '<INPUT TYPE="radio" NAME="select_section_type" VALUE="ext" CHECKED>Интернет (внешний)' ;
   print '<BR><INPUT TYPE="radio" NAME="select_section_type" VALUE="int">Пользователи (локальный)' ;
   print "</TD><TD>" ;
   print '<INPUT TYPE="radio" NAME="select_datetime_range" VALUE="current_month" CHECKED>за текущий месяц' ;
   print '<BR><INPUT TYPE="radio" NAME="select_datetime_range" VALUE="pervision_month">за предыдущий месяц' ;
   print '<BR><INPUT TYPE="radio" NAME="select_datetime_range" VALUE="through_manual_range">за диапазон дат' ;
   print "</TD><TD>" ;   
   %monthsList = ( 1 => "января", 2 => "февраля", 3 => "марта", 4 => "апреля", 5 => "мая", 6 => "июня", 7 => "июля", 8 => "августа", 9 => "сентября", 10 => "октября", 11 => "ноября", 12 => "декабря") ;
   $current_day = `date +%d` ; $current_day =~ s/[\r\n]+//g ; if ( $current_day =~ /0([0-9])/ ) { $current_day = $1 ; }
   $current_month = `date +%m` ; $current_month =~ s/[\r\n]+//g ; if ( $current_month =~ /0([0-9])/ ) { $current_month = $1 ; } 
   $current_year = `date +%Y` ; $current_year =~ s/[\r\n]+//g ;
   print "<TABLE WIDHT=\"100%\"><TR><TD>с&nbsp;</TD><TD><SELECT NAME=\"select_condition_from_range_day\" LENGHT=\"2\">" ; for ($i=1;$i<=31;$i++) { my $day = $i ; if ($i < 10) { $day = "0$i" ; } if ( $i == $current_day ) { print "<OPTION VALUE=\"$day\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$day\">$i" ; } }
   print "</SELECT>/<SELECT NAME=\"select_condition_from_range_month\" LENGHT=\"2\">" ; for ($i=1;$i<=12;$i++) { my $month = $i ; if ($i < 10) { $month = "0$i" ; } if ( $i == $current_month ) { print "<OPTION VALUE=\"$month\" SELECTED>$monthsList{$i}" ; } else { print "<OPTION VALUE=\"$month\">$monthsList{$i}" ; } }
   print "</SELECT>/<SELECT NAME=\"select_condition_from_range_year\" LENGHT=\"4\">" ; for ($i=2000;$i<=2100;$i++) { if ( $i == $current_year ) { print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }
   print "</SELECT></TD></TR><TR><TD>по&nbsp;</TD><TD>" ;
   print "<SELECT NAME=\"select_condition_to_range_day\" LENGHT=\"2\">" ; for ($i=1;$i<=31;$i++) { my $day = $i ; if ($i < 10) { $day = "0$i" ; } if ( $i == $current_day ) { print "<OPTION VALUE=\"$day\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$day\">$i" ; } }
   print "</SELECT>/<SELECT NAME=\"select_condition_to_range_month\" LENGHT=\"2\">" ; for ($i=1;$i<=12;$i++) { my $month = $i ; if ($i < 10) { $month = "0$i" ; } if ( $i == $current_month ) { print "<OPTION VALUE=\"$month\" SELECTED>$monthsList{$i}" ; } else { print "<OPTION VALUE=\"$month\">$monthsList{$i}" ; } }
   print "</SELECT>/<SELECT NAME=\"select_condition_to_range_year\" LENGHT=\"4\">" ; for ($i=2000;$i<=2100;$i++) { if ( $i == $current_year ) {  print "<OPTION VALUE=\"$i\" SELECTED>$i" ; } else { print "<OPTION VALUE=\"$i\">$i" ; } }
   print "</SELECT></TD></TR></TABLE>" ;
   print "</TD></TR><TR><TD CLASS=\"tdhead\" COLSPAN=\"3\">Детализация выборки</TD></TR><TR><TD COLSPAN=\"3\">" ;
   print '<INPUT TYPE="radio" NAME="select_detalization" VALUE="per_section" CHECKED>в разрезе по подсетям (тарификационным зонам траффика)' ;
   print '<BR><INPUT TYPE="radio" NAME="select_detalization" VALUE="per_ip">в разрезе по IP адресам' ;
   print '<BR><INPUT TYPE="radio" NAME="select_detalization" VALUE="per_day">в разрезе по датам' ;
   print '<HR><INPUT TYPE="checkbox" NAME="is_sql_query_view">Показать текст SQL запроса' ;
   print "</TD></TR></TABLE>" ;   
   print '<TABLE BORDER="0" WIDTH="100%"><TR><TD ALIGN=center><BR><input TYPE="submit" Value="Выполнить  запрос"><input TYPE="reset" Value="Отменить выполнение"><BR>&nbsp;</TD></TR></TABLE>' ;
   }   
else {
# - расчитать все префиксы условий, необходимые для правильного учета траффика SNAT в отчетах по внутренней сети / пользователям
# - в данном случае, в силу особенностей именования пакетов ULOG, входящий SNAT траффик нужно учитывать как исходящий, 
# - а исходящий - как входящий
    $select_in_per_counters_prefix =  "" ; $select_out_per_counters_prefix =  "" ; $select_in_accept_per_counters_prefix =  "" ; 
    $select_in_drop_per_counters_prefix =  "" ; $select_out_accept_per_counters_prefix =  "" ; $select_out_drop_per_counters_prefix =  "" ; 
    $intext_section_type =  $request{select_section_type} ;
    for ($i=0;$i<=$#blacklistSections;$i++) { $blacklistSections[$i] =~ s/[\r\n]*//g ; my($numSection,$pathToList,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $blacklistSections[$i]) ; 
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) { 
	   if ( $select_in_per_counters_prefix ne "" ) { $select_in_per_counters_prefix .= " OR " ; } $select_in_per_counters_prefix .= "ulog_prefix = '$statPrefix"."inaccept' OR ulog_prefix = '$statPrefix"."indrop' " ;
           if ( $select_out_per_counters_prefix ne "" ) { $select_out_per_counters_prefix .= " OR " ; } $select_out_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outaccept' OR ulog_prefix = '$statPrefix"."outdrop' " ;
           if ( $select_in_accept_per_counters_prefix ne "" ) { $select_in_accept_per_counters_prefix .= " OR " ; } $select_in_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix"."inaccept' " ; 	     
           if ( $select_in_drop_per_counters_prefix ne "" ) { $select_in_drop_per_counters_prefix .= " OR " ; } $select_in_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix"."indrop' " ; 	     
           if ( $select_out_accept_per_counters_prefix ne "" ) { $select_out_accept_per_counters_prefix .= " OR " ; } $select_out_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outaccept' " ; 	     
           if ( $select_out_drop_per_counters_prefix ne "" ) { $select_out_drop_per_counters_prefix .= " OR " ; } $select_out_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outdrop' " ; } }
    for ($i=0;$i<=$#filterSections;$i++) { $filterSections[$i] =~ s/[\r\n]*//g ; my($numSection,$intName,$isDynInt,$intIP,$Network,$useBroadcast,$ipBroadcast,$asServer,$asClient,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $filterSections[$i]) ;
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) {
	   if ( $select_in_per_counters_prefix ne "" ) { $select_in_per_counters_prefix .= " OR " ; } $select_in_per_counters_prefix .= "ulog_prefix = '$statPrefix"."inaccept' OR ulog_prefix = '$statPrefix"."indrop' " ;
           if ( $select_out_per_counters_prefix ne "" ) { $select_out_per_counters_prefix .= " OR " ; } $select_out_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outaccept' OR ulog_prefix = '$statPrefix"."outdrop' " ; 
           if ( $select_in_accept_per_counters_prefix ne "" ) { $select_in_accept_per_counters_prefix .= " OR " ; } $select_in_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix"."inaccept' " ; 	     
           if ( $select_in_drop_per_counters_prefix ne "" ) { $select_in_drop_per_counters_prefix .= " OR " ; } $select_in_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix"."indrop' " ; 	     
           if ( $select_out_accept_per_counters_prefix ne "" ) { $select_out_accept_per_counters_prefix .= " OR " ; } $select_out_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outaccept' " ; 	     
           if ( $select_out_drop_per_counters_prefix ne "" ) { $select_out_drop_per_counters_prefix .= " OR " ; } $select_out_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix"."outdrop' " ; } }
    my $in_modificator = "in" ; my $out_modificator = "out" ; if ( $request{select_section_type} eq "int" ) { $in_modificator = "out" ; $out_modificator = "in" ; } 
    for ($i=0;$i<=$#snatSections;$i++) { $snatSections[$i] =~ s/[\r\n]*//g ; my($numSection,$fromIntName,$fromAddr,$toIntName,$toAddr,$allowRecord,$isConntrackUse,$statPrefix,$statDescription,$isIncIntStat,$isIncExtStat) = split(/&/, $snatSections[$i]) ;
        if ( ($intext_section_type eq "ext" && $isIncExtStat =~ /[Yy][Ee][Ss]/) || ($intext_section_type eq "int" && $isIncIntStat =~ /[Yy][Ee][Ss]/) ) {
	   if ( $select_in_per_counters_prefix ne "" ) { $select_in_per_counters_prefix .= " OR " ; } $select_in_per_counters_prefix .= "ulog_prefix = '$statPrefix$in_modificator"."accept' OR ulog_prefix = '$statPrefix$in_modificator"."drop' " ;
           if ( $select_out_per_counters_prefix ne "" ) { $select_out_per_counters_prefix .= " OR " ; } $select_out_per_counters_prefix .= "ulog_prefix = '$statPrefix$out_modificator"."accept' OR ulog_prefix = '$statPrefix$out_modificator"."drop' " ; 
           if ( $select_in_accept_per_counters_prefix ne "" ) { $select_in_accept_per_counters_prefix .= " OR " ; } $select_in_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix$in_modificator"."accept' " ; 	     
           if ( $select_in_drop_per_counters_prefix ne "" ) { $select_in_drop_per_counters_prefix .= " OR " ; } $select_in_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix$in_modificator"."drop' " ; 	     
           if ( $select_out_accept_per_counters_prefix ne "" ) { $select_out_accept_per_counters_prefix .= " OR " ; } $select_out_accept_per_counters_prefix .= "ulog_prefix = '$statPrefix$out_modificator"."accept' " ; 	     
           if ( $select_out_drop_per_counters_prefix ne "" ) { $select_out_drop_per_counters_prefix .= " OR " ; } $select_out_drop_per_counters_prefix .= "ulog_prefix = '$statPrefix$out_modificator"."drop' " ; } }



     if ( $request{select_section_type} eq "ext" ) { print "<P>Отработан запрос по статистике внешнего ip траффика за " ; }
     if ( $request{select_section_type} eq "int" ) { print "<P>Отработан запрос по статистике внутреннего ip траффика за " ; }
     if ( $request{select_datetime_range} eq "current_month") { $select_from_date_range = "$currYear-$currMonth-01 00:00:00" ; $curr_to_day = normalize_day($currYear,$currMonth,31) ; $select_to_date_range = "$currYear-$currMonth-$curr_to_day 23:59:59" ; print "текущий месяц (с $select_from_date_range по $select_to_date_range)" ; }
     if ( $request{select_datetime_range} eq "pervision_month") { $select_from_date_range = "$prevYear-$prevMonth-01 00:00:00" ; $prev_to_day = normalize_day($prevYear,$prevMonth,31) ; $select_to_date_range = "$prevYear-$prevMonth-$prev_to_day 23:59:59" ; print "предыдущий месяц (с $select_from_date_range по $select_to_date_range)" ; }
     if ( $request{select_datetime_range} eq "through_manual_range" ) {
        $request{select_condition_from_range_day} = normalize_day($request{select_condition_from_range_year},$request{select_condition_from_range_month},$request{select_condition_from_range_day}) ; $select_from_date_range = "$request{select_condition_from_range_year}-$request{select_condition_from_range_month}-$request{select_condition_from_range_day} 00:00:00" ; 
        $request{select_condition_to_range_day} = normalize_day($request{select_condition_to_range_year},$request{select_condition_to_range_month},$request{select_condition_to_range_day}) ; $select_to_date_range = "$request{select_condition_to_range_year}-$request{select_condition_to_range_month}-$request{select_condition_to_range_day} 23:59:59" ; 
        print "указанный диапазон (с $select_from_date_range по $select_to_date_range)" ; }
     if ( $request{select_detalization} eq "per_section" ) { print " в разрезе по подсетям (зонам тарификации траффика). Результат:</P><BR>" ;
        calc_and_view_per_section_stat($request{select_section_type},$select_from_date_range,$select_to_date_range) ; }
     if ( $request{select_detalization} eq "per_ip" ) { print " в разрезе по ip адресам. Результат:</P><BR>" ;
        calc_and_view_per_ip_stat($request{select_section_type},$select_from_date_range,$select_to_date_range) ; }
     if ( $request{select_detalization} eq "per_day" ) { print " в разрезе по датам. Результат:</P><BR>" ;
        calc_and_view_per_date_stat($request{select_section_type},$select_from_date_range,$select_to_date_range) ; }
     }

print '<HR COLOR="navy"><BR>&nbsp;</BODY></HTML>' ;
